SystemOrganization addCategory: #'System-Settings-Browser'!
SystemOrganization addCategory: #'System-Settings-Core'!
SystemOrganization addCategory: #'System-Settings-Filter'!
SystemOrganization addCategory: #'System-Settings-Menu'!
SystemOrganization addCategory: #'System-Settings-Style'!
SystemOrganization addCategory: #'System-Settings-PreferencesReplacing-toBeDispatched'!

!String class methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 15:02'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForString! !

DialogWindow subclass: #SettingPackageChooser
	instanceVariableNames: 'list listIndex listSelections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingPackageChooser commentStamp: 'alain.plantec 4/20/2009 21:38' prior: 0!
A SettingPackageChooser is a model for a PluggableListMorphOfMany view which allows the chosing of several packages from the list of all system packages. 

!

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:06'!
chooseFrom: aList 
	list := aList.
	listSelections := nil.
	self updateList! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:14'!
chosen
	| chosen |
	chosen := OrderedCollection new.
	1
		to: self list size
		do: [:i | (self listSelections at: i)
				ifTrue: [chosen
						add: (self list at: i)]].
	^ chosen! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:18'!
chosen: aList 
	listSelections := nil.
	aList
		do: [:i | (self list
						indexOf: i
						ifAbsent: [])
				ifNotNil: [:idx | self listSelections at: idx put: true]].
	self updateList.! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/18/2009 07:11'!
deselectAll
	listSelections := nil.
	self updateList
	
	! !

!SettingPackageChooser methodsFor: 'user interface' stamp: 'alain.plantec 3/17/2009 22:12'!
initialExtent
	"Answer the initial extent for the receiver.
	Adjust the text if the text	would be wider than 1/4
	the display width."
	^ (super initialExtent x max: 250)
		@ 500! !

!SettingPackageChooser methodsFor: 'initialization' stamp: 'alain.plantec 3/17/2009 17:43'!
initialize
	super initialize.
	self title: 'Choose'.
! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:01'!
list
	^ list
		ifNil: [list := SortedCollection new]! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:01'!
listIndex
	^ listIndex ifNil: [listIndex := 0]					
! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:02'!
listIndex: anInteger
	listIndex := anInteger.
	self changed: #listIndex
! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 4/2/2009 13:40'!
listMorph
	^ PluggableListMorphOfMany
						on: self
						list: #list
						primarySelection: #listIndex
						changePrimarySelection: #toggleListIndex:
						listSelection: #listSelectionAt:
						changeListSelection: #listSelectionAt:put:
						menu: nil! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:07'!
listSelectionAt: index
	^ self listSelections at: index! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:33'!
listSelectionAt: index put: value
	^ listSelections at: index put: value! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:04'!
listSelections
	listSelections ifNil: [
		list ifNotNil: [
			listSelections := Array new: list size withAll: false]].
	^ listSelections! !

!SettingPackageChooser methodsFor: 'user interface' stamp: 'alain.plantec 3/18/2009 07:09'!
newButtons
	^ {self
		newButtonFor: self
		getState: nil
		action: #deselectAll
		arguments: nil
		getEnabled: nil
		label: 'Deselect all' translated
		help: 'Deselect all packages' translated}, super newButtons! !

!SettingPackageChooser methodsFor: 'user interface' stamp: 'alain.plantec 3/17/2009 22:11'!
newContentMorph
	| col |
	col := (self newRow: {self listMorph vResizing: #spaceFill; hResizing: #spaceFill})
				vResizing: #spaceFill.
	^ col vResizing: #spaceFill! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:08'!
toggleListIndex: newListIndex

	listIndex ~= 0 ifTrue: [listSelections at: listIndex put: false].
	newListIndex ~= 0 ifTrue: [listSelections at: newListIndex put: true].
	listIndex := newListIndex.
	self changed: #listIndex.
	self contentsChanged! !

!SettingPackageChooser methodsFor: 'updating' stamp: 'alain.plantec 3/17/2009 22:06'!
updateList
	self changed: #list.
! !

!Color class methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 14:48'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForColor! !

MorphTreeNodeModel subclass: #SettingCheckListNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!SettingCheckListNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 13:39'!
checked
	^ model isCheckedNode: self! !

!SettingCheckListNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 13:35'!
checked: aBoolean
	model checked: aBoolean from: self! !

!SettingCheckListNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/2/2009 12:09'!
inputRowMorphFor: aContainer 
	^ UITheme current
			newCheckboxIn: World
			for: self
			getSelected: #checked
			setSelected: #checked:
			getEnabled: nil
			label: item asString
			help: nil! !

MorphTreeNodeModel subclass: #SettingListNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!SettingListNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/2/2009 15:56'!
inputMorphFor: aContainer
	^ item inputMorphFor: aContainer! !

!SettingListNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/2/2009 15:56'!
labelMorphFor: aContainer 
	^ item labelMorphFor: aContainer! !

MorphTreeNodeModel subclass: #SettingTreeNode
	instanceVariableNames: 'parentName pragma contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingTreeNode commentStamp: 'alain.plantec 4/20/2009 21:42' prior: 0!
A SettingTreeNode is used by a SettingCollector as a node for setting trees. Built trees can be viewed by a SettingBrowser

Instance Variables
	contents:		<Collection of SettingTreeNode>
	parentNode:		<SettingTreeNode or nil>

contents
	- the children

parentNode
	- the parent or nil if the node is a root
!

!SettingTreeNode methodsFor: 'comparing' stamp: 'alain.plantec 3/3/2009 22:46'!
<= other
	^ self asString <= other asString! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 07:33'!
allChildren
	^ self model childrenOf: self.
! !

!SettingTreeNode methodsFor: 'menu' stamp: 'alain.plantec 9/19/2009 09:14'!
browseDeclaration
	"open a browser on the method which defines myself"
	ToolSet browse: self methodClass class selector: self selector! !

!SettingTreeNode methodsFor: 'checking' stamp: 'AlainPlantec 12/13/2009 21:59'!
checkForUnknownTarget
	self parentNode ifNotNil: [:p | item target ifNil: [item target: p item target].
		item targetSelector ifNil: [item targetSelector: p item targetSelector]].
	self allChildren do: [:c | c checkForUnknownTarget]! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 08:52'!
contents
	(self settingDeclaration hasValue
			and: [self settingValue = false])
		ifTrue: [^ OrderedCollection new]
		ifFalse: [^ contents 
				ifNil: [contents := self allChildren.
					self settingDeclaration ordering
						ifTrue: [contents := contents asArray sort: self model sortBlock].
					contents := self model retainedNodesFromList: contents asOrderedCollection]]! !

!SettingTreeNode methodsFor: 'menu' stamp: 'alain.plantec 4/3/2009 07:59'!
deeplyDetect: aBlock 
	(aBlock value: self) ifTrue: [^ self].
	self contents do: [:sub | (sub deeplyDetect: aBlock) ifNotNil: [:found | ^ found]].
	^ nil! !

!SettingTreeNode methodsFor: 'menu' stamp: 'alain.plantec 4/3/2009 07:57'!
deeplySelect: aBlock in: aCollection
	(aBlock value: self) ifTrue: [aCollection add: self].
	self contents do: [:sub | sub deeplySelect: aBlock in: aCollection].
	^ aCollection! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 9/18/2009 16:06'!
description
	^ self settingDeclaration description! !

!SettingTreeNode methodsFor: 'menu' stamp: 'AlainPlantec 11/24/2009 15:24'!
exploreItem
	self settingDeclaration explore! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 9/18/2009 16:38'!
icon
	^ self settingDeclaration ifNotNil: [:d | d icon ] ! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/11/2009 09:46'!
inputMorphFor: aContainer
	^ self settingDeclaration 
		ifNotNil: [:v | v inputMorphFor: aContainer]! !

!SettingTreeNode methodsFor: 'menu' stamp: 'AlainPlantec 11/24/2009 15:24'!
inspectItem
	self settingDeclaration inspect! !

!SettingTreeNode methodsFor: 'testing' stamp: 'alain.plantec 3/17/2009 09:45'!
isEmpty
	^ self contents isEmpty! !

!SettingTreeNode methodsFor: 'menu' stamp: 'alain.plantec 3/30/2009 22:56'!
keyStroke: aCharacter from: aTreeMorph 
	aCharacter = $b
		ifTrue: [self menuBrowse. ^ true].
	aCharacter = $i
		ifTrue: [self inspectItem. ^ true].
	aCharacter = $I
		ifTrue: [self exploreItem. ^ true].
	^ false
! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/23/2009 14:13'!
labelMorphFor: aContainer
	^ self settingDeclaration 
		ifNotNil: [:v | v labelMorphFor: aContainer]! !

!SettingTreeNode methodsFor: 'menu' stamp: 'alain.plantec 4/2/2009 14:44'!
menu: menu shifted: b 
	menu
		add: 'Browse (b)' translated
		target: self
		selector: #browseDeclaration.
	menu
		add: 'Inspect (i)' translated
		target: self
		selector: #inspectItem.
	menu
		add: 'Explore (I)' translated
		target: self
		selector: #exploreItem.
! !

!SettingTreeNode methodsFor: 'menu' stamp: 'alain.plantec 3/23/2009 10:11'!
menuBrowse
	self browseDeclaration! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/3/2009 14:44'!
methodClass
	^ self pragma ifNotNil: [self pragma methodClass theNonMetaClass]! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/9/2009 07:52'!
order
	^ item order! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/9/2009 07:52'!
order: anInteger
	item order: anInteger! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/3/2009 14:46'!
package
	
	^ self methodClass ifNotNil: [:mc | PackageOrganizer default mostSpecificPackageOfClass: mc ifNone: []]! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 09:26'!
parent: aSymbol
	self parentName: aSymbol! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 09:27'!
parentName
	^ parentName
	! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 09:27'!
parentName: aSymbol
	parentName := aSymbol.
	! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 07:51'!
parentNode
	^ self model nodeNamed: self parentName! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 4/1/2009 22:14'!
path
	^ self pathIn: OrderedCollection new.! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 4/1/2009 22:16'!
pathIn: aCollection 
	self parentNode
		ifNotNil: [(aCollection includes: self parentNode)
		ifFalse: [self parentNode pathIn: aCollection]].
	aCollection add: self.
	^ aCollection! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 14:51'!
pragma
	^ pragma! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 07:38'!
pragma: aPragma
	pragma := aPragma! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/27/2009 10:25'!
receiver
	^ item receiver! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/27/2009 10:27'!
receiverPackage
	^ self receiver
		ifNotNil: [PackageOrganizer default
				mostSpecificPackageOfClass: self receiver class
				ifNone: []] ! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/3/2009 14:46'!
selector
	^ self pragma ifNotNil: [:p | p selector]! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 07:11'!
settingDeclaration
	^ self item! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 9/18/2009 23:40'!
settingValue
	^ self settingDeclaration realValue
! !

!SettingTreeNode methodsFor: 'updating' stamp: 'alain.plantec 9/18/2009 23:47'!
updateAccordingTo: aFilter 
	self contents do: [ :n | n updateAccordingTo: aFilter ].
	self contents removeAllSuchThat: [ :n | n isEmpty and: [ (aFilter keepSettingTreeNode: n) not ] ]! !

!Association methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/24/2009 23:20'!
settingFixedDomainValueNodeFrom: aSettingNode 
	^ aSettingNode fixedDomainValueNodeForAssociation: self! !

!LogicalFont methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/19/2009 10:02'!
settingStoreOn: aStream 
	aStream nextPut: $(.
	aStream nextPutAll: self class name.
	aStream nextPut: Character space.
	aStream nextPutAll: 'familyName: '.
	self familyName settingStoreOn: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: 'fallbackFamilyNames: '.
	self fallbackFamilyNames settingStoreOn: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: 'pointSize: '.
	self pointSize settingStoreOn: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: 'stretchValue: '.
	self stretchValue settingStoreOn: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: 'weightValue: '.
	self weightValue settingStoreOn: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: 'slantValue: '.
	self slantValue settingStoreOn: aStream.
	aStream nextPut: $)! !

!Point class methodsFor: '*system-settings-browser' stamp: 'alain.plantec 4/21/2009 09:57'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForPoint! !

MorphTreeModel subclass: #SettingBrowser
	instanceVariableNames: 'roots status searchedText showSelectors treeHolder'
	classVariableNames: 'InitialExtent'
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

SettingBrowser class
	instanceVariableNames: 'searchedTextList regexpSearch'!

!SettingBrowser commentStamp: 'alain.plantec 4/20/2009 16:01' prior: 0!
A SettingBrowser is a model for a setting viewer. A SettingBrowser view allow the browsing as well as the editing of setting values (Viewed setting are declared by a method with a particular pragma. See SettingManager comments to see which kinds of setting are available and how-to declare them).
For each setting, a label (which, according to a global switch, is its names or its method selector) is shown and along with the label, an input widget allowing the change of the setting value is also shown.

In order to know which settings are to be viewed, a setting browser must know the pragma keyword used to declare them. This is why a setting browser must be initialized with a set of regular expressions: all retained pragma keyword are matching at least one of the regular expression. Then, when opened, only settings which are declared with a retained pragma keyword are viewed.

Examples:
--------------------
(SettingBrowser forKeywords: #('blob.*')) open.
--------------------
Only settings which are declared with a keyword matching 'blob.*' regular expression are viewed.
Here is en example of such a setting declared in the class side of a class BlobSettings 
--------------------
BlobSettings class>>blob
	<blobSetting>
	^ SettingManager newNode: 'Blob parameters'
--------------------

In order to open a setting browser one can also use the simpler expression below:
--------------------
SettingBrowser browse: #('setting').
--------------------
It browses all settings declared with a pragma keyword which is matching the 'setting' regular expression.


A SettingBrowser view implements a filtering functionality. Two filtering modes are allowed: by token or by regular expression.
- by token: a sub-string is entered and, when accepted, only settings for which name, description, pragma class or method selector includes these token are viewed;
- by regular expression: the same as by token except that the input is used as a regular expression.

Instance Variables
	roots:		<Collection of SettingTreeNode>
	searchedText:		<String>
	status:		<WriteStream>
	collector:		<SettingCollector>

roots
	- the roots of the viewed setting trees

searchedText
	- the string used as a filter token or regexp in order to select viewed settings

status
	- a WriteStream used in order to store useful information which are shown when no current item is selected

collector
	- The SettingCollector which has the responsibility to collect settings and to build viewed trees
!

SettingBrowser class
	instanceVariableNames: 'searchedTextList regexpSearch'!

SettingBrowser subclass: #PackageSettingBrowser
	instanceVariableNames: 'viewedPackages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!PackageSettingBrowser commentStamp: 'alain.plantec 4/20/2009 14:12' prior: 0!
A PackageSettingBrowser is a SettingBrowser which provides the possibility to select viewed settings according to a set packages: only settings which are declared in selected packages are viewed.

Instance Variables
	viewedPackages:		<Set of PackageInfo>

viewedPackages
	- the set of PackageInfo used to select viewed settings
!

!PackageSettingBrowser classSide methodsFor: 'opening' stamp: 'alain.plantec 3/30/2009 10:16'!
open
	^ self new open! !

!PackageSettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 3/30/2009 10:18'!
applyFilters
	| filter |
	super applyFilters.
	self viewedPackages
		ifNotEmpty: [filter := SettingPackageFilter new
						packages: self viewedPackages.
			self updateAccordingTo: filter].
	self updateList! !

!PackageSettingBrowser methodsFor: 'user interface' stamp: 'AlainPlantec 12/5/2009 16:02'!
buildWindowIn: aWindow 
	| statusView toolBar treeMorph toolBarY gap localGap menuBar menuBarY packageListView statusViewHeight |
	treeMorph := self treeMorphIn: aWindow.
	statusView := self statusViewIn: aWindow.
	statusViewHeight := 100.
	toolBar := self toolBarIn: aWindow.
	menuBar := self menuBarIn: aWindow.
	menuBar submorphs ifEmpty: [menuBarY := 0] 
	ifNotEmpty: [menuBarY := menuBar minExtent y.
	aWindow 
		addMorph: menuBar
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ 0 corner: 0 @ menuBarY))].
	localGap := 5.
	gap := localGap + menuBarY.
	packageListView := self packageListViewIn: aWindow.
	toolBarY := toolBar minExtent y + gap.
	aWindow 
		addMorph: toolBar
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ (gap ) corner: 0 @ (toolBarY + localGap))).
	aWindow 
		addMorph: treeMorph
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 0.99)
				offsets: (0 @ (toolBarY + localGap + localGap) corner: 0 @ statusViewHeight negated)).
	aWindow 
		addMorph: statusView
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0.99 corner: 0.75 @ 1)
				offsets: (0 @ statusViewHeight negated corner: 0 @ 0)).
	aWindow 
		addMorph: packageListView
		fullFrame: (LayoutFrame 
				fractions: (0.75 @ 0.99 corner: 1 @ 1)
				offsets: (0 @ statusViewHeight negated corner: 0 @ 0)).
	^ aWindow! !

!PackageSettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 4/23/2009 14:59'!
changePackageSet: aSet 
	aSet ~= self viewedPackages
		ifTrue: [self viewedPackages: aSet.
			self applyFilters].
	^ true! !

!PackageSettingBrowser methodsFor: 'user interface' stamp: 'alain.plantec 3/30/2009 10:16'!
choosePackagesIn: aWindow
	| chooser allPackages chosen |
	allPackages := PackageOrganizer default packageNames asSortedCollection.
	chosen := self viewedPackages collect: [:p | p packageName].
	aWindow openModal: (chooser := SettingPackageChooser new chooseFrom: allPackages; chosen: chosen; yourself).
	chooser cancelled
		ifFalse: [self changePackageSet: (chooser chosen collect: [:c | PackageOrganizer default packageNamed: c ifAbsent: []])] ! !

!PackageSettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 07:50'!
getDescription
	^ self selectedNode
		ifNil: [super getDescription]
		ifNotNil: [:selected | Text
				streamContents: [:s |
					selected  package ifNotNil: [:pkg |
						s nextPutAll: (Text string: 'Package: ', pkg packageName attribute: TextEmphasis bold).
						s nextPut: Character cr].
					s nextPutAll: super getDescription]]! !

!PackageSettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/8/2009 12:02'!
getViewedPackageNames
	^ Text
		streamContents: [:s | self viewedPackages
				ifEmpty: [s nextPutAll: 'All packages' translated]
				ifNotEmpty: [:selections | 
					(selections asSet = MCWorkingCopy allManagers asSet)
						ifTrue: [s nextPutAll: 'All packages']
						ifFalse: [selections
								do: [:package | 
									s nextPutAll: package packageName.
									s nextPut: Character space]]]]! !

!PackageSettingBrowser methodsFor: 'user interface' stamp: 'alain.plantec 3/30/2009 10:16'!
packageListViewIn: aWindow
	^ aWindow
				newTextEditorFor: self
				getText: #getViewedPackageNames
				setText: #setViewedPackageNames:.
! !

!PackageSettingBrowser methodsFor: 'dependents access' stamp: 'alain.plantec 3/30/2009 10:37'!
release
	viewedPackages := nil.
	super release.! !

!PackageSettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 10:16'!
setViewedPackageNames: aText 
	| allViewed |
	allViewed := Set new.
	aText asString subStrings
		do: [:sub | (PackageOrganizer default
						packageNamed: sub
						ifAbsent: [])
				ifNotNil: [:pkg | allViewed add: pkg]].
	self changePackageSet: allViewed.
	self changed: #getViewedPackageNames
! !

!PackageSettingBrowser methodsFor: 'user interface' stamp: 'alain.plantec 4/8/2009 23:57'!
toolBarIn: aMorph 
	| toolBar |
	toolBar := super toolBarIn: aMorph.
	toolBar
		addMorphBack: aMorph newToolbarHandle.
	toolBar
		addMorphBack:aMorph newToolSpacer.	
	toolBar
		addMorphBack:aMorph newToolSpacer.
	toolBar
		addMorphBack: (aMorph
				newButtonFor: self
				getState: nil
				action: #choosePackagesIn:
				arguments: {aMorph}
				getEnabled: nil
				label: 'Choose packages' translated 
				help: 'Select packages' translated).
	toolBar addMorphBack: aMorph newToolSpacer.
	^ toolBar! !

!PackageSettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 3/30/2009 10:28'!
updateList
	super updateList.
	self changed: #getViewedPackageNames
	

	
! !

!PackageSettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 10:16'!
viewedPackages
	^ viewedPackages
		ifNil: [viewedPackages := Set new]! !

!PackageSettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 10:16'!
viewedPackages: aCollectionOfPackagesOrNil
	viewedPackages:= aCollectionOfPackagesOrNil! !

PackageSettingBrowser subclass: #SystemMenuBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Menu'!

!SystemMenuBrowser methodsFor: 'menu' stamp: 'AlainPlantec 11/26/2009 07:32'!
keyStroke: aCharacter from: aTreeMorph 
	super keyStroke: aCharacter from: aTreeMorph.
	(self selectedNode)
		ifNotNil: [:current | aCharacter = $p 
				ifTrue: [^ self menuPopUp]]! !

!SystemMenuBrowser methodsFor: 'menu' stamp: 'AlainPlantec 11/26/2009 07:32'!
menu: menu shifted: b 
	super menu: menu shifted: b.
	(self selectedNode)
		ifNotNil: [:current | menu
				add: 'Popup (p)' translated
				target: self
				selector: #menuPopUp].
	^ menu! !

!SystemMenuBrowser methodsFor: 'menu' stamp: 'AlainPlantec 11/26/2009 07:32'!
menuPopUp
	(self selectedNode)
		ifNotNil: [:current | 
			| menu | 
			menu := MenuMorph new.
			self node: current menuItemIn: menu.
			menu popUpEvent: nil in: World]! !

!SystemMenuBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 11:46'!
newTreeHolder
	^ super newTreeHolder acceptableKeywords: {SettingMenuAssembler worldMenuKeyword}! !

!SystemMenuBrowser methodsFor: 'menu' stamp: 'alain.plantec 4/1/2009 18:21'!
node: aTreeNode menuItemIn: aMenu 
	| sub |
	aTreeNode contents
		ifEmpty: [aTreeNode item value menuItemIn: aMenu]
		ifNotEmpty: [sub := aTreeNode item value menuItemIn: aMenu.
			aTreeNode contents
				do: [:c | c item value menuItemIn: sub]]! !

PackageSettingBrowser subclass: #SystemSettingBrowser
	instanceVariableNames: ''
	classVariableNames: 'DefaultPragmaKeyword StyleNameClassSuffix UserStylePackageNamePrefix UserStylePackageNameSuffix'
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SystemSettingBrowser commentStamp: 'alain.plantec 4/21/2009 15:17' prior: 0!
A SystemSettingBrowser is a PackageSettingBrowser which is specialized in order to view and manage standard system settings (settings which are declared with the standard pragma keyword 'setting'). 
SystemSettingBrowser also provides the management of setting styles: one can create, update, delete and load user defined styles. A user defined style is a SettingStyle subclass which implement a specific #load method.
The SystemSettingBrowser use following rule in order to name a setting class: 
if N if the name given by the user for the setting, then the class name is: ((N, SystemSettingBrowser styleNameClassSuffix value) asIdentifier: true).
Such a setting class is owned by a package named: 
((SystemSettingBrowser userStylePackageNamePrefix value asIdentifier: true), '-', (SystemSettingBrowser userStylePackageNameSuffix value)).

HOW-TO BROWSE SYSTEM SETTINGS

Default settings are defined with the default pragma keyword 'setting'. In order to browse all of them, one can open the system setting browser with:
------------------
SystemSettingBrowser open
------------------

Other pragma keywords are allowed. A particular package or a particular application can make use of a specific keyword. As an example, the pragma keyword 'myOwnKeyword' can be used. Then, in order to browse such specific settings, the system setting browser can be opened as follow:
------------------
SystemSettingBrowser browse: #('myOwnKeyword').
------------------

In order to browse system settings defined with the 'setting' keyword and those which are defined with the 'myOwnKeyword' keyword all together, the browser can be opened like this:
------------------
SystemSettingBrowser browse: #('setting' 'myOwnKeyword').
------------------

HOWTO BROWSE INTERNAL SETTINGS

SystemSettingBrowser class>>styleNameClassSuffix and SystemSettingBrowser class>>userStylePackageNamePrefixdeclares are internal settings. Internal setting pragma keyword is given by SettingBrowser class>>#internalSettingKeyword. SystemSettingBrowser internal settings can be browsed and their value can be changed from a SettingBrowser opened as follow:
----------------
((SettingBrowser forKeywords: {SettingBrowser internalSettingKeyword}) pragmaProvider: SystemSettingBrowser) open
----------------

Or simply, from the configuration menu of a SystemSettingBrowser.

!

!SystemSettingBrowser classSide methodsFor: 'internal settings' stamp: 'AlainPlantec 11/27/2009 09:30'!
defaultPragmaKeyword
	^ DefaultPragmaKeyword
		ifNil: [DefaultPragmaKeyword := 'systemsettings']! !

!SystemSettingBrowser classSide methodsFor: 'internal settings' stamp: 'AlainPlantec 11/13/2009 11:18'!
defaultPragmaKeyword: aString
	DefaultPragmaKeyword := aString.
! !

!SystemSettingBrowser classSide methodsFor: 'internal settings' stamp: 'AlainPlantec 11/27/2009 18:54'!
defaultPragmaKeywordOn: aBuilder 
	<SettingBrowserSetting>
	(aBuilder setting: #defaultPragmaKeyword) order: 0;
		 default: 'systemsettings';
		 ghostHelp: 'A regular expression' translated;
		 description: 'The pragma keyword which is used by default' translated! !

!SystemSettingBrowser classSide methodsFor: 'internal settings' stamp: 'AlainPlantec 11/27/2009 18:52'!
styleNameClassSuffix
	^ StyleNameClassSuffix
		ifNil: [StyleNameClassSuffix := 'SystemSettingsStyle']! !

!SystemSettingBrowser classSide methodsFor: 'internal settings' stamp: 'alain.plantec 9/17/2009 21:45'!
styleNameClassSuffix: aString
	StyleNameClassSuffix := aString
! !

!SystemSettingBrowser classSide methodsFor: 'internal settings' stamp: 'AlainPlantec 11/27/2009 18:52'!
userStyleOn: aBuilder 
	<SettingBrowserSetting>
	(aBuilder group: #userStyle) label: 'User style' translated;
		
		with: [(aBuilder setting: #styleNameClassSuffix) label: 'Classname suffix' translated;
				 default: 'SystemSettingsStyle';
				 description: 'A setting style is stored as a class which name is the style name suffixed with the value of this setting.
As an example, if the value of this setting is "SettingStyle" then, for a style named "Favorite", the corresponding style class name is "FavoriteSettingStyle".' translated.
			(aBuilder group: #'Package naming')
				with: [(aBuilder setting: #userStylePackageNamePrefix) label: 'Prefix' translated;
						 default: 'UserStyle';
						 description: 'A setting style is stored as a class which name is the style name suffixed with the value of this setting.
As an example, if the value of this setting is "SettingStyle" then, for a style named "Favorite", the corresponding style class name is "FavoriteSettingStyle".' translated.
					(aBuilder setting: #userStylePackageNameSuffix) label: 'Suffix' translated;
						 default: 'Settings';
						 description: 'A setting style is stored as a class which name is the style name suffixed with the value of this setting.
As an example, if the value of this setting is "SettingStyle" then, for a style named "Favorite", the corresponding style class name is "FavoriteSettingStyle".' translated]]! !

!SystemSettingBrowser classSide methodsFor: 'internal settings' stamp: 'AlainPlantec 11/27/2009 18:51'!
userStylePackageNamePrefix
	^ UserStylePackageNamePrefix ifNil: [UserStylePackageNamePrefix := 'UserStyle']! !

!SystemSettingBrowser classSide methodsFor: 'internal settings' stamp: 'alain.plantec 9/17/2009 21:46'!
userStylePackageNamePrefix: aString
	UserStylePackageNamePrefix := aString
! !

!SystemSettingBrowser classSide methodsFor: 'internal settings' stamp: 'AlainPlantec 11/27/2009 18:52'!
userStylePackageNameSuffix
	^ UserStylePackageNameSuffix ifNil: [UserStylePackageNameSuffix := 'Settings']! !

!SystemSettingBrowser classSide methodsFor: 'internal settings' stamp: 'alain.plantec 9/17/2009 21:48'!
userStylePackageNameSuffix: aString
	UserStylePackageNameSuffix := aString
! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 4/8/2009 12:03'!
about
	self inform: 'Here you can browse, query and change all system settings' translated! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
browseStyle
	| allStyleClasses cls |
	allStyleClasses := (SettingStyle allSubclasses asSortedCollection: [:a :b | a name < b name]) asOrderedCollection.
	cls := UIManager default chooseFrom: (allStyleClasses collect: [:c | c styleName]) values: allStyleClasses.
	cls ifNotNil: [ToolSet browse: cls selector: #load]! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/23/2009 10:31'!
buildDefaultStyle
	| code |
	code := 	code := self styleLoadCode: true.
	SettingStyle
		subclass: self defaultSettingStyleClassName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: SettingStyle category.
	self defaultSettingStyleClass compile: code classified: #loading.
	self defaultSettingStyleClass class
		compile: (('styleName\	^ ''Default'' translated') withCRs)
		classified: #accessing! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 4/21/2009 10:12'!
buildUserDefinedStyleNamed: aName classname: aClassname code: loadCode
	SettingStyle
		subclass: aClassname
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self userStylePackageName.
	(Smalltalk at: aClassname) 
		compile: loadCode
		classified: #loading.
	(Smalltalk at: aClassname) class
		compile: ('styleName\	^ ''', aName, '''') withCRs
		classified: #accessing! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 10/19/2009 15:50'!
changeSettingGroupKeyword
	| group |
	(group := UIManager default request: 'New setting keyword' initialAnswer:  '')
		ifNotNil: [self acceptableKeywords: {group ifNotEmpty: [group] ifEmpty: [self defaultSettingGroupKeyword]}]! !

!SystemSettingBrowser methodsFor: 'user interface' stamp: 'alain.plantec 10/19/2009 15:33'!
configurationMenuIn: aWindow
	| configurationMenu |
	configurationMenu := aWindow newMenu.
	configurationMenu
		addToggle: 'Browse internal settings' translated
		target: self
		selector: #browseInternalSettings.
	configurationMenu lastItem font: aWindow theme menuFont.
	configurationMenu
		addToggle: 'Change setting group' translated
		target: self
		selector: #changeSettingGroupKeyword.
	configurationMenu lastItem font: aWindow theme menuFont.
	configurationMenu
		addToggle: 'Build default style' translated
		target: self
		selector: #buildDefaultStyle.
	configurationMenu lastItem font: aWindow theme menuFont.
	^ configurationMenu! !

!SystemSettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 11/13/2009 11:09'!
defaultSettingGroupKeyword
	^ self class defaultPragmaKeyword! !

!SystemSettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/20/2009 14:42'!
defaultSettingStyleClass
	^ Smalltalk at: self defaultSettingStyleClassName ifAbsent: []! !

!SystemSettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/20/2009 14:42'!
defaultSettingStyleClassName
	^ #DefaultSettingStyle! !

!SystemSettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 07:32'!
getCodeText
	^ self selectedNode
		ifNil: ['']
		ifNotNil: [:s | 
			| code | 
			code := s item realReceiver class
						sourceCodeAt: s item selector 
						ifAbsent: [''].
			code
				ifEmpty: [''] 
				ifNotEmpty: [s item receiver name , '>>' , code]]! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'AlainPlantec 12/7/2009 15:11'!
helpDeclaringAndManagingSettings
	"Open up a workspace with explanatory info in it about the Preference Browser"
	Workspace new
		contents: "SettingManager comment;" 'To be documented here later';
		openLabel: 'Declaring and managing settings' translated! !

!SystemSettingBrowser methodsFor: 'user interface' stamp: 'alain.plantec 4/21/2009 14:52'!
helpMenuIn: aWindow
	| helpMenu |
	helpMenu := aWindow newMenu.
	helpMenu
		addToggle: 'About' translated
		target: self
		selector: #about.
	helpMenu lastItem font: aWindow theme menuFont.
	helpMenu
		addToggle: 'Declaring and managing settings' translated
		target: self
		selector: #helpDeclaringAndManagingSettings.
	helpMenu lastItem font: aWindow theme menuFont.
	^ helpMenu
! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/31/2009 09:28'!
loadStyle
	| allStyleClasses cls |
	allStyleClasses := (SettingStyle allSubclasses
				asSortedCollection: [:a :b | a name < b name]) asOrderedCollection.
	cls := UIManager default
				chooseFrom: (allStyleClasses
						collect: [:c | c styleName])
				values: allStyleClasses.
	cls
		ifNotNil: [cls new loadStyleFrom: self. self changed: #getDescription]! !

!SystemSettingBrowser methodsFor: 'user interface' stamp: 'alain.plantec 10/19/2009 15:13'!
menuBarIn: aWindow
	| menuBar |
	menuBar := super menuBarIn: aWindow.
	menuBar
		add: 'Style' translated
		font: aWindow theme menuBarFont
		icon: nil
		help: 'Style creation, loading or removal operations' translated
		subMenu: (self styleMenuIn: aWindow).
	menuBar
		add: 'Configuration' translated
		font: aWindow theme menuBarFont
		icon: nil
		help: nil
		subMenu: (self configurationMenuIn: aWindow).
	menuBar addSpacer.
	menuBar addSpacer.
	menuBar
		add: 'Help' translated
		font: aWindow theme menuBarFont
		icon: nil
		help: nil
		subMenu: (self helpMenuIn: aWindow).
	^ menuBar
! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 9/21/2009 09:30'!
newStyle
	| name clsName usedName |
	name := UIManager default request: 'Give the new style name.' translated initialAnswer: 'MyOwn' translated.
	name ifNotNil: [ name
		ifNotEmpty: [
			usedName := ''.
			name subStrings do: [:s | s at: 1 put: (s first asUppercase). usedName := usedName, s].
			clsName := ((usedName
						, (self class styleNameClassSuffix value)) asIdentifier: true) asSymbol.
			(Smalltalk
						at: clsName
						ifAbsent: [])
				ifNotNil: [:cls | UITheme current alertIn: World text: clsName , ' ' , 'already exists, sorry' translated title: 'Invalid new style name' translated configure: [:d | ]].
			self buildUserDefinedStyleNamed: name classname: clsName code: (self styleLoadCode: false)]]! !

!SystemSettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 11:46'!
newTreeHolder
	^ super newTreeHolder acceptableKeywords: {self defaultSettingGroupKeyword}! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
removeStyle
	| allStyleClasses cls |
	allStyleClasses := (SettingStyle allSubclasses asSortedCollection: [:a :b | a name < b name]) asOrderedCollection.
	allStyleClasses remove: self defaultSettingStyleClass.
	cls := UIManager default chooseFrom: (allStyleClasses collect: [:c | c styleName]) values: allStyleClasses.
	cls ifNotNil: [(UIManager confirm: 'Definitively remove style' translated,' "', cls styleName, '" ?')
		ifTrue: [Smalltalk removeClassNamed: cls name]]! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'AlainPlantec 12/3/2009 16:22'!
styleLoadCode: forDefault 
	^ String
		streamContents: [:s | s nextPutAll: 'load'; nextPut: Character cr.
			(self treeHolder nodeList select: [:node | node item hasValue and: [node item allowedInStyle]]) 
				do: [:node | 
					| decl |
					decl := node item.
					s nextPut: $[;
						 nextPutAll: (decl target isSymbol ifTrue: [decl target] ifFalse: [decl target name]);
						 nextPutAll: (decl targetSelector ifNil: [''] ifNotNil: [' ', decl targetSelector]);
						 nextPutAll: ' ', decl setSelector, ' '.
					forDefault
						ifTrue: [decl defaultValue settingStoreOn: s]
						ifFalse: [decl realValue settingStoreOn: s].
					s nextPut: $];
						 nextPutAll: ' on: Error do: [|message| message := ''Error while changing the setting: #' , decl name ,'.''.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]]';
						 nextPut: $.;
						 cr]]! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 9/21/2009 09:25'!
styleLoaded
	self updateList! !

!SystemSettingBrowser methodsFor: 'user interface' stamp: 'alain.plantec 3/24/2009 16:58'!
styleMenuIn: aWindow
	| styleMenu |
	styleMenu := aWindow newMenu.
	styleMenu
		addToggle: 'New' translated
		target: self
		selector: #newStyle.
	styleMenu lastItem font: aWindow theme menuFont.
	styleMenu
		addToggle: 'Update' translated
		target: self
		selector: #updateStyle.
	styleMenu lastItem font: aWindow theme menuFont.
	styleMenu
		addToggle: 'Load' translated
		target: self
		selector: #loadStyle.
	styleMenu lastItem font: aWindow theme menuFont.
	styleMenu
		addToggle: 'Browse' translated
		target: self
		selector: #browseStyle.
	styleMenu lastItem font: aWindow theme menuFont.
	styleMenu
		addToggle: 'remove' translated
		target: self
		selector: #removeStyle.
	styleMenu lastItem font: aWindow theme menuFont.
	^ styleMenu! !

!SystemSettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/20/2009 14:42'!
taskbarIcon
	^ MenuIcons smallConfigurationIcon! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
updateStyle
	| allStyleClasses cls |
	allStyleClasses := (SettingStyle allSubclasses asSortedCollection: [:a :b | a name < b name]) asOrderedCollection.
	cls := UIManager default chooseFrom: (allStyleClasses collect: [:c | c styleName]) values: allStyleClasses.
	cls ifNotNil: [self buildUserDefinedStyleNamed: cls styleName classname: cls name code: (self styleLoadCode: false)]! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 9/21/2009 09:22'!
userStylePackageName
	^ (self class userStylePackageNamePrefix asIdentifier: true), '-', self class userStylePackageNameSuffix.
! !

!SystemSettingBrowser methodsFor: 'user interface' stamp: 'alain.plantec 4/6/2009 00:35'!
windowTitle
	^ 'System setting browser'! !

!SettingBrowser class methodsFor: 'opening' stamp: 'alain.plantec 4/13/2009 14:44'!
browse: aCollectionOfKeywordRegExp
	"open a SettingBrowser view which is able to browse all settings 
	that are declared with a pragma keyword which matches at least
	one of the regular expression contained in aCollectionOfKeywordRegExp
	example:
	(SettingBrowser browse: #('sett.*'))
	browse all settings which make use of a pragma keyword which matches
	the regular expression 'sett.*'.
	
	Note that the default setting pragma keyword is 'setting'
	and that the SystemSettingBrowser specialization is 
	dedicated to these settings.
	"
	(self forKeywords: aCollectionOfKeywordRegExp) open! !

!SettingBrowser class methodsFor: 'opening' stamp: 'alain.plantec 4/13/2009 14:33'!
forKeywords: aCollectionOfRegExps
	"create a new SettingBrowser initialized with a set of pragma keywords"
	^ self new acceptableKeywords: aCollectionOfRegExps! !

!SettingBrowser class methodsFor: 'internal settings' stamp: 'AlainPlantec 12/13/2009 22:54'!
initialExtent
	^ InitialExtent ifNil: [InitialExtent := 835@600]
		! !

!SettingBrowser class methodsFor: 'internal settings' stamp: 'alain.plantec 9/17/2009 21:44'!
initialExtent: aPoint
	InitialExtent := aPoint
		! !

!SettingBrowser class methodsFor: 'internal settings' stamp: 'AlainPlantec 12/9/2009 23:28'!
initialExtentOn: aBuilder
	<SettingBrowserSetting>
	(aBuilder setting: #initialExtent) 
		label: 'Setting browser initial extent';
		default: 850@600
		! !

!SettingBrowser class methodsFor: 'internal settings' stamp: 'alain.plantec 4/21/2009 09:42'!
internalSettingKeyword
	^ #SettingBrowserSetting! !

!SettingBrowser class methodsFor: 'opening' stamp: 'alain.plantec 4/13/2009 14:33'!
open
	"Open a SettingBrowser view"
	^ self new open! !

!SettingBrowser class methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 11/30/2009 10:22'!
refreshAllSettingBrowsers
	self allSubInstances do: [:sb | sb updateList]! !

!SettingBrowser class methodsFor: 'accessing' stamp: 'alain.plantec 4/20/2009 09:24'!
regexpSearch
	^ regexpSearch ifNil: [regexpSearch := false]! !

!SettingBrowser class methodsFor: 'accessing' stamp: 'alain.plantec 4/20/2009 09:24'!
regexpSearch: aBoolean
	regexpSearch := aBoolean! !

!SettingBrowser class methodsFor: 'accessing' stamp: 'alain.plantec 4/20/2009 09:18'!
searchedTextList
	^ searchedTextList ifNil: [searchedTextList := OrderedCollection new]! !

!SettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 11:44'!
acceptableKeywords: aCollectionOfRegExps 
	self treeHolder acceptableKeywords: aCollectionOfRegExps ! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/23/2009 15:03'!
addToSearchedTextList: aString
	(self searchedTextList includes: aString) 
		ifFalse: [self searchedTextList size > 5 ifTrue: [self searchedTextList removeFirst].
		self searchedTextList add: aString]! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/2/2009 14:12'!
addToStatus: aText 
	self status nextPutAll: aText.
! !

!SettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 4/23/2009 14:59'!
applyFilters
	roots := nil.
	self searchedText
		ifNotEmpty: [self updateAccordingTo: self textFilter].
	self updateList ! !

!SettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 9/18/2009 16:24'!
browseInternalSettings
	((SettingBrowser forKeywords: {self class internalSettingKeyword})) open! !

!SettingBrowser methodsFor: 'user interface' stamp: 'alain.plantec 4/1/2009 10:28'!
buildWindowIn: aWindow 
	| statusView toolBar treeMorph toolBarY gap localGap menuBar menuBarY |
	treeMorph := self treeMorphIn: aWindow.
	statusView := self statusViewIn: aWindow.
	toolBar := self toolBarIn: aWindow.
	menuBar := self menuBarIn: aWindow.
	menuBar submorphs ifEmpty: [menuBarY := 0] 
	ifNotEmpty: [menuBarY := menuBar minExtent y.
	aWindow 
		addMorph: menuBar
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ 0 corner: 0 @ menuBarY))].
	localGap := 5.
	gap := localGap + menuBarY.
	toolBarY := toolBar minExtent y + gap.
	aWindow 
		addMorph: toolBar
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ (gap ) corner: 0 @ (toolBarY + localGap))).
	aWindow 
		addMorph: treeMorph
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 0.99)
				offsets: (0 @ (toolBarY + localGap + localGap) corner: 0 @ 100 negated)).
	aWindow 
		addMorph: statusView
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0.99 corner: 1 @ 1)
				offsets: (0 @ 100 negated corner: 0 @ 0)).
	^ aWindow! !

!SettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 4/23/2009 14:59'!
changeSearchedText: aString 
	self searchedText ~= aString
		ifTrue: [self searchedText: aString.
			self applyFilters].
	^ true ! !

!SettingBrowser methodsFor: 'updating' stamp: 'AlainPlantec 11/27/2009 22:09'!
closePathFrom: aSetting 
	(self settingNodeOfDeclaration: aSetting)
		ifNotNil: [:node | self changed: {#roots. #closeItemPath}, (node path collect: [:n | n withoutListWrapper])]! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 9/19/2009 09:51'!
deeplyDetect: aBlock 
	self roots
		do: [:sub | (sub deeplyDetect: aBlock)
				ifNotNil: [:found | ^ found]].
	^ nil ! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 10/19/2009 15:29'!
defaultSettingGroupKeyword
	^ 'setting'! !

!SettingBrowser methodsFor: 'menu' stamp: 'AlainPlantec 12/1/2009 15:51'!
doubleClick
	self selectedNode ifNotNil: [:node | node browseDeclaration]! !

!SettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 3/23/2009 18:38'!
expandAll
	self changed: #(#roots #expandAll).
! !

!SettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 07:30'!
getDescription
	^ (self selectedNode)
		ifNil: [self status contents ifEmpty: ['Hit return in text fields to accept the input' translated]]
		ifNotNil: [:selection | (Text string: selection item label attribute: TextEmphasis bold), String cr, selection item description]! !

!SettingBrowser methodsFor: 'user interface' stamp: 'alain.plantec 9/21/2009 09:40'!
initialExtent
	^ self class initialExtent! !

!SettingBrowser methodsFor: 'user interface' stamp: 'AlainPlantec 12/1/2009 09:10'!
isRendered
	| renderingMorphs |
	renderingMorphs := SystemWindow allSubInstances select: [:sw | sw model = self].
	^ renderingMorphs anySatisfy: [:m | m owner notNil]! !

!SettingBrowser methodsFor: 'menu' stamp: 'AlainPlantec 11/26/2009 07:30'!
keyStroke: aCharacter from: aTreeMorph 
	self selectedNode
		ifNotNil: [:current | current keyStroke: aCharacter from: aTreeMorph.
			current settingDeclaration hasDefault
				ifTrue: [aCharacter = $d
						ifTrue: [^ self menuSetToDefault: current]].
			current settingDeclaration hasEditableList
				ifTrue: [aCharacter = $e
						ifTrue: [^ self menuEmptyList: current]]]! !

!SettingBrowser methodsFor: 'menu' stamp: 'AlainPlantec 11/26/2009 07:31'!
menu: menu shifted: b 
	"Set up the menu to apply to the receiver's, 
	honoring the #shifted boolean"
	self selectedNode ifNotNil: [:current | current menu: menu shifted: b].
	menu addLine.
	(self selectedNode)
		ifNotNil: [:current | 
			current settingDeclaration hasDefault
				ifTrue: [menu
						add: 'Set to default (d)' translated
						target: self
						selector: #menuSetToDefault:
						argument: current].
			current settingDeclaration hasEditableList
				ifTrue: [menu
						add: 'Empty list (e)' translated
						target: self
						selector: #menuEmptyList:
						argument: current]].
	menu addLine.
	menu
		add: (self showSelectors ifTrue: ['Show setting names' translated] ifFalse: ['Show selectors' translated])
		target: self
		selector: #switchShowSelectors.
	menu addLine.
	menu
		add: 'Set all to default' translated
		target: self
		selector: #setAllToDefault.
	^ menu! !

!SettingBrowser methodsFor: 'user interface' stamp: 'alain.plantec 4/1/2009 10:10'!
menuBarIn: aWindow
	^ aWindow newToolDockingBar.
! !

!SettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 10/19/2009 14:49'!
menuEmptyList: aTreeNode
	| v |
	(v := aTreeNode settingDeclaration) hasEditableList 
		ifTrue: [v emptyList. self updateList]! !

!SettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 10/19/2009 14:17'!
menuSetToDefault: aTreeNode
	| v |
	(v := aTreeNode settingDeclaration) hasDefault
		ifTrue: [(self confirm: 'Set to default value ?' translated)
				ifTrue: [v setToDefault. self updateList]]! !

!SettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 11:46'!
newTreeHolder
	^ SettingTreeHolder new ! !

!SettingBrowser methodsFor: 'user interface' stamp: 'alain.plantec 10/19/2009 15:28'!
open
	| window |
	Cursor wait
		showWhile: [window := StandardWindow new model: self.
			window title: self windowTitle.
			self buildWindowIn: window.
			window themeChanged.
			window openInWorld.
			^ window]! !

!SettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 10/19/2009 00:53'!
openPathFrom: aSetting
	(self settingNodeOfDeclaration: aSetting) ifNotNil: [:node |
		self changed: {#roots. #openItemPath}, (node path collect: [:n | n withoutListWrapper])]! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/27/2009 23:04'!
pragmaErrorOccured: aPragmaError
	self setDescription: aPragmaError message, String cr! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/23/2009 15:01'!
regexpSearch
	^ self class regexpSearch! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/23/2009 15:02'!
regexpSearch: aBoolean
	self class regexpSearch: aBoolean.
	self applyFilters 
! !

!SettingBrowser methodsFor: 'dependents access' stamp: 'AlainPlantec 11/24/2009 11:47'!
release
	treeHolder release.
	treeHolder := nil.
	roots := nil.
	status := nil.
	searchedText := nil.
	super release.! !

!SettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 11:44'!
roots
	^ roots ifNil: [roots := self treeHolder settingTreeRoots]
! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/8/2009 08:58'!
searchedText
	^ searchedText ifNil: [searchedText := '']! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 18:38'!
searchedText: aString
	searchedText := aString.
! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/20/2009 09:19'!
searchedTextList
	^ self class searchedTextList! !

!SettingBrowser methodsFor: 'updating' stamp: 'AlainPlantec 11/18/2009 08:28'!
selection: aSelectionHolder
	super selection: aSelectionHolder.
	self setDescription: ''.
	self changed: #getDescription
! !

!SettingBrowser methodsFor: 'menu' stamp: 'AlainPlantec 11/24/2009 11:44'!
setAllToDefault
	(self confirm: 'Set all to default value ?' translated) ifTrue: [
		self treeHolder nodeList do: [:node | node item hasDefault ifTrue: [node item setToDefault]].
		self updateList]! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/2/2009 14:12'!
setDescription: aText 
	self status reset.
	self addToStatus: aText.
	self changed: #getDescription! !

!SettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 11:44'!
settingNodeOfDeclaration: aSettingDeclaration
	^ self treeHolder deeplyDetect: [:n | n settingDeclaration = aSettingDeclaration]! !

!SettingBrowser methodsFor: 'updating' stamp: 'AlainPlantec 11/27/2009 22:08'!
settingValueChanged: aSetting 
	aSetting realValue = true
		ifTrue: [self openPathFrom: aSetting].
	aSetting realValue = false
		ifTrue: [self closePathFrom: aSetting].
	aSetting changed: #realValue.
	aSetting changed: #fontButtonLabel.
	aSetting changed: #index.
	aSetting changed: #content ! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/23/2009 14:54'!
showSelectors
	^ showSelectors ifNil: [showSelectors := false]! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/23/2009 14:54'!
showSelectors: aBoolean
	showSelectors := aBoolean.
	self updateList ! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/2/2009 14:11'!
status
	^ status ifNil: [status := String new writeStream]! !

!SettingBrowser methodsFor: 'user interface' stamp: 'alain.plantec 3/23/2009 18:38'!
statusViewIn: aMorph
	| statusView |
	statusView := aMorph
				newTextEditorFor: self
				getText: #getDescription
				setText: #setDescription:.
	^ statusView
 ! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 10/19/2009 14:59'!
switchShowSelectors
	self showSelectors: self showSelectors not! !

!SettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 4/23/2009 15:01'!
textFilter
	^ self regexpSearch
		ifFalse: [SettingTokenFilter new token: self searchedText]
		ifTrue: [SettingRegexpFilter new regexp: self searchedText] ! !

!SettingBrowser methodsFor: 'user interface' stamp: 'alain.plantec 10/19/2009 15:01'!
toolBarIn: aMorph
	| toolBar |
	toolBar := aMorph newToolbar: {
	aMorph
		newButtonFor: self
		getState: nil
		action: #expandAll
		arguments: nil
		getEnabled: nil
		label: 'Expand all' translated
		help: 'Expand all tree nodes' translated.
	aMorph newToolSpacer.
	aMorph newToolbarHandle.
	aMorph newToolSpacer.
	aMorph newLabel: 'Search for: ' translated.
	(EditableDropListMorph
				on: self
				list: #searchedTextList
				selected: #searchedText
				changeSelected: #changeSearchedText:
				useIndex: false 
				addToList: #addToSearchedTextList:
				class: String
				getEnabled: nil) hResizing: #spaceFill; 
				ghostText: 'Hit return to accept' translated.
	aMorph
			newCheckboxFor: self
			getSelected: #regexpSearch
			setSelected: #regexpSearch:
			getEnabled: nil
			label: 'Regexp' 
			help: 'Filter according to a regular expression' translated.
	aMorph newToolSpacer}.

	^ toolBar
! !

!SettingBrowser methodsFor: 'updating' stamp: 'AlainPlantec 11/18/2009 08:31'!
treeChanged: anAnnounce
	roots := nil.
	self selection: nil.
	self updateList! !

!SettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 11:42'!
treeHolder
	^ treeHolder
		ifNil: [treeHolder := self newTreeHolder whenChangedSend: #treeChanged: to: self; yourself]! !

!SettingBrowser methodsFor: 'user interface' stamp: 'AlainPlantec 12/5/2009 15:48'!
treeMorphIn: aMorph
	| treeMorph |
	treeMorph := MorphTreeMorph 
						on: self 
						list: #roots
						selected: #selection
						changeSelected: #selection:
						menu: #menu:shifted:
						keystroke: #keyStroke:from:
						columns: {
							(MorphTreeColumn new) startWidth: 300; 
								rowMorphGetSelector: #labelMorphFor:;
								yourself.
							(MorphTreeColumn new) 
								rowMorphGetSelector: #inputMorphFor:;
								yourself
						}.
	treeMorph	selectionColor: aMorph theme selectionColor;
				doubleClickSelector: #doubleClick;
				makeLastColumnUnbounded;
				cornerStyle: aMorph preferredCornerStyle;
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				withHLines: false;
				hCellInset: 4;
				vCellInset: 6;
				resizerWidth: 4;
				arrange;
				rowColorForEven: Color veryLightGray muchLighter;
				preferedPaneColor: Color veryLightGray lighter lighter;
				yourself.
	^ treeMorph
! !

!SettingBrowser methodsFor: 'updating' stamp: 'AlainPlantec 11/18/2009 08:27'!
updateAccordingTo: aFilter
	self selection: nil.
	self setDescription: ''.
	roots := nil.
	self updateList.
	[self roots
		do: [:r | r updateAccordingTo: aFilter].
	self roots
		removeAllSuchThat: [:n | n isEmpty
				and: [(aFilter keepSettingTreeNode: n) not]]]
		on: RegexSyntaxError
		do: [:ex | 
			self setDescription: 'Regular expression syntax error, see `documentation'' protocol of RxParser class for user''s guide'].
	self expandAll! !

!SettingBrowser methodsFor: 'updating' stamp: 'AlainPlantec 12/1/2009 09:11'!
updateList
	self isRendered ifTrue: [
		self treeHolder updateList.
		self changed: #roots.
		self changed: #getDescription].	
! !

!SettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 4/2/2009 14:12'!
updateStatusWith: aMessage
	self addToStatus: aMessage.
	self addToStatus: Character cr.
! !

!SettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 12/14/2009 13:06'!
viewedLabelOfSetting: aSettingDeclaration 
	| node |
	node := self settingNodeOfDeclaration: aSettingDeclaration.
	^ node 
		ifNil: [aSettingDeclaration label]
		ifNotNil: [self showSelectors
			ifTrue: [node methodClass name , '>>' , node selector]
			ifFalse: [(node allChildren notEmpty and: [aSettingDeclaration hasValue])
				ifTrue: [aSettingDeclaration label, '...'] 
				ifFalse: [aSettingDeclaration label]]]! !

!SettingBrowser methodsFor: 'user interface' stamp: 'alain.plantec 4/8/2009 12:01'!
windowTitle
	^ 'Setting browser' translated! !

MorphTreeModel subclass: #SettingCheckListModel
	instanceVariableNames: 'settingDeclaration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!SettingCheckListModel methodsFor: 'selecting' stamp: 'AlainPlantec 11/26/2009 14:04'!
checked: aBoolean from: node
	| l |
	l := settingDeclaration realValue asSet.
	aBoolean 
		ifTrue: [l add: node item]
		ifFalse: [l remove: node item ifAbsent: []].
	settingDeclaration realValue: l asOrderedCollection.
! !

!SettingCheckListModel methodsFor: 'selecting' stamp: 'AlainPlantec 11/26/2009 13:39'!
isCheckedNode: node
	^ settingDeclaration realValue includes: node item ! !

!SettingCheckListModel methodsFor: 'user interface' stamp: 'AlainPlantec 12/2/2009 12:10'!
listMorph
	| listMorph selected |
	listMorph	:= MorphTreeMorph on: self
				list: #roots
				multiSelection: true
				columns: {MorphTreeColumn new rowMorphGetSelector: #inputRowMorphFor:}.
	listMorph preferedPaneColor: Color white.
	^ listMorph! !

!SettingCheckListModel methodsFor: 'accessing' stamp: 'AlainPlantec 12/2/2009 11:55'!
roots
	^ settingDeclaration domainValues 
		collect: [:dv | SettingCheckListNode with: dv realValue model: self]! !

!SettingCheckListModel methodsFor: 'selecting' stamp: 'AlainPlantec 11/26/2009 14:05'!
selection: aSelection
! !

!SettingCheckListModel methodsFor: 'accessing' stamp: 'AlainPlantec 12/2/2009 12:04'!
settingDeclaration: aDeclaration
	settingDeclaration := aDeclaration! !

MorphTreeModel subclass: #SettingListModel
	instanceVariableNames: 'settingDeclaration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!SettingListModel methodsFor: 'user interface' stamp: 'AlainPlantec 12/2/2009 17:33'!
listMorph
	| listMorph selected |
	listMorph	:= MorphTreeMorph on: self
				list: #roots
				multiSelection: true
				columns: {	(MorphTreeColumn new) 
								rowMorphGetSelector: #inputMorphFor:;
								yourself
						}.
	listMorph preferedPaneColor: Color white.
	listMorph hResizing: #rigid.
	listMorph vResizing: #rigid.
	listMorph width: listMorph columns first contentWidth + 20.
	^ listMorph! !

!SettingListModel methodsFor: 'accessing' stamp: 'AlainPlantec 12/2/2009 15:56'!
roots
	^ settingDeclaration domainValues 
		collect: [:dv | SettingListNode with: dv model: self]! !

!SettingListModel methodsFor: 'selecting' stamp: 'AlainPlantec 12/2/2009 15:13'!
selection: aSelection
! !

!SettingListModel methodsFor: 'accessing' stamp: 'AlainPlantec 12/2/2009 17:37'!
settingDeclaration: aDeclaration
	settingDeclaration := aDeclaration.
	settingDeclaration default: (Array withAll: (settingDeclaration domainValues collect: [:rv | rv realValue]))! !

!SettingListModel methodsFor: 'updating' stamp: 'AlainPlantec 12/2/2009 17:45'!
settingValueChanged: aSettingDeclaration
	settingDeclaration realValue at: (settingDeclaration domainValues indexOf: aSettingDeclaration) put: aSettingDeclaration realValue! !

!SettingListModel methodsFor: 'user interface' stamp: 'AlainPlantec 12/2/2009 15:57'!
viewedLabelOfSetting: aSetting
	^ aSetting label! !

!AbstractFont class methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 14:49'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForFont! !

!Number class methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 15:09'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForNumber! !

!Boolean class methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 14:48'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForBoolean! !

Object subclass: #AppearanceSystemSettings
	instanceVariableNames: ''
	classVariableNames: 'DesktopColor DesktopGradientDirection DesktopGradientFillColor DesktopGradientOrigin DesktopImageFileName UseDesktopGradientFill'
	poolDictionaries: ''
	category: 'System-Settings-PreferencesReplacing-toBeDispatched'!

!AppearanceSystemSettings classSide methodsFor: 'root setting' stamp: 'AlainPlantec 12/15/2009 10:56'!
appearanceOn: aBuilder 
	<systemsettings>
	(aBuilder group: #appearance)
		label: 'Appearance' translated; 
		description: 'All settings concerned with the look''n feel of your system' translated;
		noOrdering;
		with: [
			self morphicAppearanceOn: aBuilder.
			self desktopColorOn: aBuilder.
			(aBuilder pickOne: #displayDepth)
				label: 'Display depth' translated; 
				order: 10;
				target: #Display;
				notInStyle;
				getSelector: #depth;
				setSelector: #newDepth:;
				domainValuesGetter: (MessageSend receiver: self selector: #depthChoices).
			(aBuilder setting: #displayFullscreen)
				label: 'Fullscreen mode' translated;
				target: #Display;
				getSelector: #isFullScreen;
				setSelector: #fullScreen:;
				description: 'On platforms that support it, set full-screen mode' translated;
				default: false.
			]! !

!AppearanceSystemSettings classSide methodsFor: 'root setting' stamp: 'AlainPlantec 11/30/2009 14:24'!
depthChoices
	| oldDepth allDepths hasBoth allLabels |
	oldDepth := Display nativeDepth.
	allDepths := #(1 -1 2 -2 4 -4 8 -8 16 -16 32 -32 )
				select: [:d | Display supportsDisplayDepth: d].
	hasBoth := (allDepths anySatisfy: [:d | d > 0]) and: [allDepths anySatisfy: [:d | d < 0]].
	allLabels := allDepths
				collect: [:d | String
						streamContents: [:s | 
							s print: d abs.
							hasBoth
								ifTrue: [s
										nextPutAll: (d > 0
												ifTrue: ['  (big endian)']
												ifFalse: ['  (little endian)'])]]].
	^ (allLabels with: allDepths collect: [:l :d | l -> d]) asArray sort: [:a :b | a value < b value]
! !

!AppearanceSystemSettings classSide methodsFor: 'desktop' stamp: 'AlainPlantec 12/1/2009 20:46'!
desktopBackgroundChanged
	| fill |
	self desktopImageFileName
		ifNotEmpty: [^ [Form setBackgroundFromImageFileNamed: self desktopImageFileName]
				on: Error
				do: []].
	self useDesktopGradientFill
		ifTrue: [World fillStyle isGradientFill
				ifTrue: [fill := World fillStyle]
				ifFalse: [fill := GradientFillStyle new].
			fill colorRamp: {0.0 -> self desktopColor darker. 1.0 -> self desktopGradientFillColor lighter}.
			fill origin: (World perform: self desktopGradientOrigin).
			self desktopGradientDirection = #Vertical
				ifTrue: [fill radial: false.
					fill normal: World width @ 0.
					fill direction: 0 @ World height].
			self desktopGradientDirection = #Horizontal
				ifTrue: [fill radial: false.
					fill normal: 0 @ World height.
					fill direction: World width @ 0]. 
			self desktopGradientDirection = #Radial
				ifTrue: [
					fill radial: true.
					self desktopGradientOrigin = #center
						ifTrue: [fill direction: World width // 2 @ 0.
							fill normal: 0 @ (World height // 2)]
						ifFalse: [fill direction: World width @ 0.
							fill normal: 0 @ World height]].
			World fillStyle: fill]
		ifFalse: [World color: self desktopColor].
		World changed! !

!AppearanceSystemSettings classSide methodsFor: 'desktop' stamp: 'AlainPlantec 12/3/2009 15:57'!
desktopColor
	^ DesktopColor ifNil: [DesktopColor := World defaultWorldColor]! !

!AppearanceSystemSettings classSide methodsFor: 'desktop' stamp: 'AlainPlantec 11/28/2009 15:50'!
desktopColor: aColor
	DesktopColor := aColor.
	self desktopBackgroundChanged! !

!AppearanceSystemSettings classSide methodsFor: 'desktop' stamp: 'AlainPlantec 12/14/2009 13:10'!
desktopColorOn: aBuilder 
	(aBuilder group: #desktopBackground)
		label: 'Desktop background';
		parent: #appearance;
		target: self;
		noOrdering;
		with: [
			(aBuilder setting: #desktopColor)
				label: 'Color';
				description: 'This is the only color of your desktop if no gradient is used. If you make use of a gradient, then this color is the first one of the gradient' translated;
				with: [
					(aBuilder setting: #useDesktopGradientFill)
						label: 'Gradient';
						description: 'If true, then more settings will be available in order to define the desktop background color gradient';
						noOrdering;
						with: [
							(aBuilder setting: #desktopGradientFillColor)
								label: 'Other color';
								description: 'This is the second color of your gradient (the first one is given by the "Color" setting' translated.
							(aBuilder pickOne: #desktopGradientDirection)
								label: 'Direction';
								domainValues: {#Horizontal. #Vertical. #Radial}.
							(aBuilder pickOne: #desktopGradientOrigin)
								label: 'Origin';
								domainValues: {
									'Top left' translated -> #topLeft. 
									'Top' translated -> #topCenter. 
									'Top right' translated -> #topRight. 
									'Right' translated -> #rightCenter.
									'Bottom right' translated ->  #bottomRight.
									'Bottom' translated -> #bottomCenter.
									'Bottom left' translated -> #bottomLeft.
									'Left' translated -> #leftCenter.
									'Center' translated -> #center}]].
			(aBuilder setting: #desktopImageFileName)
				type: #FilePath;
				description: 'The path of an png file which will be imported as a form and displayed as your desktop background' translated;
				label: 'Image file name']
						! !

!AppearanceSystemSettings classSide methodsFor: 'desktop' stamp: 'AlainPlantec 11/30/2009 06:33'!
desktopGradientDirection
	"#Radial #Vertical or #Horizontal"
	^ DesktopGradientDirection ifNil: [DesktopGradientDirection := #Vertical]! !

!AppearanceSystemSettings classSide methodsFor: 'desktop' stamp: 'AlainPlantec 11/28/2009 15:50'!
desktopGradientDirection: aSymbol
	"#Radial #Vertical or #Horizontal"
	DesktopGradientDirection := aSymbol.
	self desktopBackgroundChanged
! !

!AppearanceSystemSettings classSide methodsFor: 'desktop' stamp: 'AlainPlantec 11/30/2009 06:32'!
desktopGradientFillColor
	^ DesktopGradientFillColor ifNil: [DesktopGradientFillColor := self desktopColor]! !

!AppearanceSystemSettings classSide methodsFor: 'desktop' stamp: 'AlainPlantec 11/28/2009 15:50'!
desktopGradientFillColor: aColor 
	DesktopGradientFillColor := aColor.
	self desktopBackgroundChanged! !

!AppearanceSystemSettings classSide methodsFor: 'desktop' stamp: 'AlainPlantec 11/30/2009 06:37'!
desktopGradientOrigin
	"#topLeft #topCenter #topRight #rightCenter #bottomRight #bottomCenter #bottomLeft #leftCenter #center"
	^ DesktopGradientOrigin ifNil: [DesktopGradientOrigin := #topLeft]! !

!AppearanceSystemSettings classSide methodsFor: 'desktop' stamp: 'AlainPlantec 11/28/2009 16:10'!
desktopGradientOrigin: aSymbol
	"#Radial #Vertical or #Horizontal"
	DesktopGradientOrigin := aSymbol.
	self desktopBackgroundChanged
! !

!AppearanceSystemSettings classSide methodsFor: 'desktop' stamp: 'AlainPlantec 11/28/2009 12:00'!
desktopImageFileName
	^ DesktopImageFileName ifNil: [DesktopImageFileName := '']! !

!AppearanceSystemSettings classSide methodsFor: 'desktop' stamp: 'AlainPlantec 11/28/2009 15:47'!
desktopImageFileName: aFileName
	DesktopImageFileName := aFileName.
	self desktopBackgroundChanged! !

!AppearanceSystemSettings classSide methodsFor: 'morphic' stamp: 'AlainPlantec 12/15/2009 10:57'!
morphicAnimationOn: aBuilder 
	(aBuilder setting: #useAnimation)
		label: 'Animation' translated;
		target: UITheme;
		targetSelector: #currentAnimationSettings;
		description: 'If true, some animations will be use when opening and closing windows' translated;
		noOrdering;
		with: [
			(aBuilder setting: #animateClosing)
				label: 'Animate closing' translated;
				description: 'If true, then windows closing is animated' translated.
			(aBuilder range: #animationDelay) 
				label: 'Delay' translated;
				description: 'The delay between each step of the window animation in milliseconds.' translated;
				selector: #delay;
				range: (0 to: 30).
			(aBuilder range: #animationNumberOfSteps) 
				label: 'Number of steps' translated;
				description: 'The number of steps in the window animation.' translated;
				selector: #numberOfSteps;
				range: (0 to: 100).
		]! !

!AppearanceSystemSettings classSide methodsFor: 'morphic' stamp: 'AlainPlantec 12/15/2009 10:15'!
morphicAppearanceOn: aBuilder 
	(aBuilder group: #morphic)
		label: 'Morphic' translated;
		parent: #appearance;
		description: 'All morphic settings' translated;
		noOrdering;
		with: [
			(aBuilder pickOne: #uiThemeClass)
				label: 'User interface theme' translated;
				target: self;
				order: 1;
				domainValuesGetter: (MessageSend receiver: self selector: #uiThemeClassChoices).
			self morphicWindowsOn: aBuilder.
			self morphicMenuOn: aBuilder.
			self morphicHaloOn: aBuilder.
			self morphicAnimationOn: aBuilder.
			(aBuilder setting: #keyboardFocusOnMouseDown)
				label: 'Keyboard focus on mouse down' translated;
				target: MorphicModel;
				description: 'When enabled the mouse button must be clicked within a morph for it to take the keyboard focus.' translated.
			(aBuilder setting: #mouseOverForKeyboardFocus)
				label: 'Lose keyboard focus when mouse leave' translated;
				target: MorphicModel;
				description: 'When true, the mouse must be over a text or list pane in morphic for keystrokes to be felt, and when the mouse is out over the desktop, the so-called desktop-command-keys, such as cmd-b and cmd-R, are honored.  When false, list panes and text panes in morphic remain sensitive to keystrokes even after the mouse is no longer over the pane.' translated.
			(aBuilder setting: #showTextEditingState)
				label: 'Show text editing state' translated;
				target: PluggableTextMorph;
				description: 'When enabled the editing state of PluggableTextMorphs is shown as a colored inset border.' translated.
			(aBuilder setting: #balloonHelpEnabled)
				label: 'Balloon help'; 
				target: Morph.
			(aBuilder setting: #editableStringMorph)
				label: 'String morphs are editable' translated;
				target: StringMorph;
				description: 'If true, editing on StringMorph is possible if the shift key is pressed while selecting the morphs.' translated.
			(aBuilder setting: #defaultYellowButtonMenuEnabled)
				label: 'Show default yellow button menu' translated;
				target: Morph;
				description: 'If true, populate a yellow-button menu (default context menu).' translated.
			(aBuilder setting: #useUndo)
				label: 'Allow command undo' translated;
				target: CommandHistory;
				description: 'If true, morphic command undo will be generally available. This option has nothing to do with text editing undo.' translated;
				with: [
					(aBuilder setting: #infiniteUndo)
						label: 'Multiple undo' translated;
						description: 'Allow multiple undo.' translated.
					(aBuilder setting: #purgeUndoOnQuit)
						label: 'Purge on quit' translated;
						description: 'If true, all kept commands will be erased on quit' translated ]]
! !

!AppearanceSystemSettings classSide methodsFor: 'morphic' stamp: 'AlainPlantec 12/13/2009 22:08'!
morphicHaloOn: aBuilder 
	(aBuilder group: #halo)
		label: 'Halo' translated;
		parent: #morphic;
		description: 'All halo settings' translated;
		noOrdering;
		with: [
			(aBuilder setting: #haloEnclosesFullBounds)
				label: 'Encloses fullbounds' translated;
				target: HaloMorph;
				description: 'If true, halos will enclose the full bounds of the target Morph, rather than just the bounds' translated.
			(aBuilder setting: #showBoundsInHalo)
				label: 'Exhibits bounds' translated;
				target: HaloMorph;
				description: 'If true, halos will include a fine rectangle around the bounds of the target morph.' translated
		]! !

!AppearanceSystemSettings classSide methodsFor: 'morphic' stamp: 'AlainPlantec 12/14/2009 19:55'!
morphicMenuOn: aBuilder 
	(aBuilder group: #menu)
		label: 'Menu' translated;
		parent: #morphic;
		description: 'All menu settings' translated;
		target: UITheme;
		targetSelector: #currentSettings;
		noOrdering;
		with: [
			(aBuilder setting: #preferGradientFill)
				label: 'Gradient filling' translated;
				description: 'If true, then menus will have a gradient look' translated.
			(aBuilder setting: #flatMenu)
				label: 'Flat appearance' translated;
				description: 'If true, then menu will without 3D like borders.' translated.
			(aBuilder setting: #autoMenuColor)
				label: 'Computed color' translated;
				description: 'If true, then the menu color will be computed from world dressing.' translated.
			(aBuilder setting: #menuWithIcons)
				label: 'Automatically added icons' translated;
				description: 'If true, then menu item will be decorated with automatically found icons.' translated.
		]! !

!AppearanceSystemSettings classSide methodsFor: 'morphic' stamp: 'AlainPlantec 12/14/2009 21:42'!
morphicWindowsOn: aBuilder 
	(aBuilder group: #windows)
		label: 'Windows' translated;
		description: 'All windows settings' translated;
		noOrdering;
		with: [
			(aBuilder setting: #preferRoundCorner)
				target: UITheme;
				targetSelector: #currentSettings;
				label: 'Rounded corners' translated;
				description: 'If true, then windows, menu and other popups will have their corners rounded.' translated.
			(aBuilder range: #fullScreenMargin) 
						target: SystemWindow;
						label: 'Full screen margin' translated;
						description: 'Specify the amount of space that is let around a windows when it''s opened fullscreen' translated;
						range: (0 to: 100).
			(aBuilder setting: #fadedBackgroundWindows)
				target: UITheme;
				targetSelector: #currentSettings;
				label: 'Fade background windows' translated;
				description: 'If true then, background windows appear more "washed out" to distinguish from the active window' translated.
			(aBuilder setting: #fastDragging)
				target: UITheme;
				targetSelector: #currentSettings;
				label: 'Fast dragging' translated;
				description: 'If true, window drag will be done by dragging an outline of the window instead of the whole window. It is very convenient on a slow machine' translated]
			
			
			
! !

!AppearanceSystemSettings classSide methodsFor: 'root setting' stamp: 'AlainPlantec 12/10/2009 16:04'!
uiThemeClass
	^ UITheme current class
! !

!AppearanceSystemSettings classSide methodsFor: 'root setting' stamp: 'AlainPlantec 12/10/2009 16:17'!
uiThemeClass: aUIThemeClass
	aUIThemeClass ifNil: [^ self].
	self uiThemeClass ~= aUIThemeClass
		ifTrue: [aUIThemeClass beCurrent]! !

!AppearanceSystemSettings classSide methodsFor: 'root setting' stamp: 'AlainPlantec 12/10/2009 16:02'!
uiThemeClassChoices
	^ UITheme allThemeClasses collect: [:c | c themeName -> c]! !

!AppearanceSystemSettings classSide methodsFor: 'desktop' stamp: 'AlainPlantec 11/30/2009 06:31'!
useDesktopGradientFill
	^ UseDesktopGradientFill ifNil: [UseDesktopGradientFill := false]! !

!AppearanceSystemSettings classSide methodsFor: 'desktop' stamp: 'AlainPlantec 11/28/2009 15:49'!
useDesktopGradientFill: aBoolean 
	UseDesktopGradientFill := aBoolean.
	self desktopBackgroundChanged! !

!Object methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/24/2009 23:21'!
settingFixedDomainValueNodeFrom: aSettingNode 
	^ aSettingNode fixedDomainValueNodeForObject: self! !

!Object methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/19/2009 09:50'!
settingStoreOn: aStream
	^ self storeOn: aStream! !

Object subclass: #PragmaSetting
	instanceVariableNames: 'precondition target targetSelector name label description order icon ordering'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!PragmaSetting commentStamp: 'alain.plantec 4/7/2009 22:59' prior: 0!
A PragmaSetting is a holder for a setting. A setting is declared in a class method which contains a pragma (as examples, <menu> or <setting>). 
Settings can be collected on the fly by a PragmaCollector and browsed by a SettingBrowser. Settings are organized in trees. The parent instance variable is set to nil when the setting is a root. Instances of concrete subclasses of PragmaSetting should not be created directly, instead, SettingManager must be used for that purpose. More documentation and examples of setting declaration are given in the SettingManager comment.

Instance Variables
	description:		<String> 
	name:				<String>
	parents:			<Collection of Symbol>
	order : 			<Number>

description
	- the description that is used in ballon help or by supporting tools (optional)

name
	- the name of the setting

parents
	- a collection of symbols, each symbol corresponds to a the method selector of a parent setting

order
	- aNumber which is used for sibling items ordering
!

PragmaSetting subclass: #MenuSettingNode
	instanceVariableNames: 'lineAfter enablement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!MenuSettingNode commentStamp: 'alain.plantec 4/21/2009 08:52' prior: 0!
A MenuSettingNode is a setting used to define a menu item.

Instance Variables
	enablement:		<Symbol>
	line:		<Boolean>
	icon:		<Form>

enablement
	- a selector, corresponding message send result is used as the enablement of the related menu item

line
	- true if one want a menu line to be added after the item in the resulting menu

icon
	- the icon form to be used in the menu item

!

MenuSettingNode subclass: #MenuElement
	instanceVariableNames: 'selector arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!MenuElement commentStamp: 'alain.plantec 4/21/2009 09:08' prior: 0!
A MenuElement specifies a concrete menu item. Such a menu item can perform an action when selected or be used as a node in a menu tree. The action is performed by sending a message to the target. The value of the selector instance variable is the name of the message.

Instance Variables
	arguments:		<Collection>
	selector:		<Symbol>
	target:		<Object>

arguments
	- a collection which serves as argument list when evaluating the menu element action

selector
	- a symbol which represent the message selector to send to the target in order to perform an action when the menu item is selected

target
	- the receiver for the menu item action (receives the message which selector is the selector instance variable value)!

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/27/2009 12:58'!
arguments
	^ arguments ifNil: [#()]! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 20:46'!
arguments: aCollection
	arguments := aCollection! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 10:13'!
children
	^#()! !

!MenuElement methodsFor: 'testing' stamp: 'alain.plantec 3/26/2009 11:12'!
enabled
	^ self enablement! !

!MenuElement methodsFor: 'menu assembling' stamp: 'AlainPlantec 11/26/2009 21:18'!
menuItemIn: aMenu 
	| newItem |
	"add a menu item to the argument"
	aMenu
		addToggle: self name
		target: self receiver 
		selector: self selector
		getStateSelector: nil
		enablementSelector: self enablement
		argumentList: self arguments.
	newItem := aMenu lastItem.
	newItem icon: self icon.
	newItem setBalloonText: description.
	self lineAfter ifTrue: [aMenu addLine].
	^ newItem
! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/27/2009 12:59'!
selector
	^ selector ! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/27/2009 12:59'!
selector: aSymbol
	selector := aSymbol! !

!MenuElement methodsFor: 'reliability' stamp: 'AlainPlantec 11/26/2009 21:18'!
testIt
	^ super testIt
		and: [(self arguments isKindOf: Collection)
						and: [self selector isNil
								or: [(self selector isKindOf: Symbol)
										and: [self receiver respondsTo: self selector]]]]! !

!MenuSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 3/27/2009 12:58'!
enablement
	^ enablement ifNil: [true]! !

!MenuSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 4/21/2009 08:50'!
enablement: aSelector
	enablement := aSelector! !

!MenuSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 10/19/2009 01:18'!
lineAfter
	^ lineAfter ifNil: [lineAfter := false]! !

!MenuSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 10/19/2009 01:18'!
lineAfter: aBoolean
	lineAfter := aBoolean! !

!MenuSettingNode methodsFor: 'menu assembling' stamp: 'alain.plantec 4/1/2009 16:05'!
menuItemIn: aMenu 
	^ aMenu! !

!MenuSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 4/2/2009 12:11'!
order
	^ order ifNil: [order := 0]! !

!MenuSettingNode methodsFor: 'sorting' stamp: 'alain.plantec 3/30/2009 15:26'!
sort
! !

!MenuSettingNode methodsFor: 'reliability' stamp: 'alain.plantec 10/19/2009 01:19'!
testIt
	^ super testIt
		and: [(self icon isNil
					or: [self icon isKindOf: Form])
				and: [(self enablement isKindOf: Boolean)
				and: [(self order isNil
							or: [self order isKindOf: Number])
						and: [self lineAfter isKindOf: Boolean]]]]! !

MenuSettingNode subclass: #MenuSiblings
	instanceVariableNames: 'menus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!MenuSiblings commentStamp: 'alain.plantec 4/8/2009 13:11' prior: 0!
A MenuSiblings represents a collection of menu nodes. It is defined for convenience: it allows the declaration of a list of menu items for one level of the menu tree with only one method. If a name is set, then, a menu item is created with the name and the siblings are accessed from that item. Thus, If a name is set, a new level is introduced in the menu tree. If a name is not set, then siblings are directly inserted without introducing a new level in the tree.

Instance Variables
	menus:		<Collection of MenuSettingNode>

!

!MenuSiblings methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 10:13'!
children
	^ menus! !

!MenuSiblings methodsFor: 'initializing' stamp: 'alain.plantec 4/7/2009 12:01'!
initialize
	super initialize.
	name := ''! !

!MenuSiblings methodsFor: 'menu assembling' stamp: 'alain.plantec 10/19/2009 01:19'!
menuItemIn: aMenu 
	| sub item |
	name value
		ifEmpty: [sub := aMenu]
		ifNotEmpty: [item := MenuItemMorph new.
			sub := MenuMorph new.
			item contents: self name value;
				 isEnabled: true;
				 icon: self icon;
				 setBalloonText: description;
				 subMenu: sub.
			aMenu addMorphBack: item].
	self children
		do: [:c |c menuItemIn: sub].
	self lineAfter
		ifTrue: [aMenu addLine].
	^ sub! !

!MenuSiblings methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 00:07'!
menus
	^ menus! !

!MenuSiblings methodsFor: 'accessing' stamp: 'alain.plantec 4/1/2009 18:31'!
menus: aCollectionOfMenuSettings
	menus := aCollectionOfMenuSettings.
	aCollectionOfMenuSettings do: [:s | s parents: self parents].
	self sort
	! !

!MenuSiblings methodsFor: 'sorting' stamp: 'alain.plantec 4/2/2009 11:46'!
sort
	menus := (menus asSortedCollection: SettingManager itemSortBlock) asOrderedCollection.
	menus do: [:item | item sort]! !

!MenuSiblings methodsFor: 'reliability' stamp: 'alain.plantec 3/27/2009 13:14'!
testIt
	super testIt
		ifFalse: [^ false].
	self menus
		do: [:m | 
			(m isKindOf: MenuSettingNode)
				ifFalse: [^ false].
			m testIt
				ifFalse: [^ false]].
	^ true ! !

!PragmaSetting methodsFor: 'comparing' stamp: 'alain.plantec 4/20/2009 15:18'!
= other 
	^ self species = other species
		and: [self name = other name]! !

!PragmaSetting methodsFor: 'user interface' stamp: 'alain.plantec 3/11/2009 15:38'!
asString
	^ self name! !

!PragmaSetting methodsFor: 'user interface' stamp: 'AlainPlantec 11/25/2009 08:25'!
defaultIcon
	^ nil! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 11/13/2009 15:52'!
description
	"Answer the value of description"

	^ description ifNil: [description := '']! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 19:36'!
description: aText
	"Set the value of description"

	description := aText! !

!PragmaSetting methodsFor: 'user interface' stamp: 'alain.plantec 3/12/2009 12:58'!
enabled
	^ true! !

!PragmaSetting methodsFor: 'comparing' stamp: 'alain.plantec 4/20/2009 15:19'!
hash
	^ self species hash bitXor: self name hash ! !

!PragmaSetting methodsFor: 'user interface' stamp: 'AlainPlantec 11/25/2009 08:27'!
icon
	^ icon ifNil: [icon := self defaultIcon]! !

!PragmaSetting methodsFor: 'user interface' stamp: 'AlainPlantec 11/23/2009 22:18'!
icon: aForm 
	icon := aForm! !

!PragmaSetting methodsFor: 'user interface' stamp: 'alain.plantec 4/9/2009 01:32'!
inputMorphFor: aContainer 
	^ self inputWidget
		ifNotNil: [:iw | 
			(UITheme current newRowIn: World for: {iw})
				 clipSubmorphs: true;
				 hResizing: #shrinkWrap;
				 cellInset: 0;
				 yourself]! !

!PragmaSetting methodsFor: 'user interface' stamp: 'alain.plantec 3/31/2009 08:14'!
inputWidget
	"nothing to input here"
	^ nil! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 11/23/2009 14:11'!
label
	^ label ifNil: [self name] ifNotNil: [label value]! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 11/23/2009 14:11'!
label: aStringOrBlockOrMessageSend
	label := aStringOrBlockOrMessageSend! !

!PragmaSetting methodsFor: 'user interface' stamp: 'AlainPlantec 11/29/2009 22:22'!
labelMorphFor: aContainer
	^ StringMorph contents: (aContainer model viewedLabelOfSetting: self)! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 10/18/2009 12:40'!
name
	^ name ifNil: [super name] ifNotNil: [name value]! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 10/18/2009 12:39'!
name: aNameOrBlockOrMessageSend
	name := aNameOrBlockOrMessageSend! !

!PragmaSetting methodsFor: 'user interface' stamp: 'AlainPlantec 11/25/2009 08:18'!
noOrdering
	ordering := false! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 4/2/2009 11:59'!
order
	^ order! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 4/2/2009 10:53'!
order: aNumber
	order := aNumber! !

!PragmaSetting methodsFor: 'user interface' stamp: 'AlainPlantec 11/25/2009 08:18'!
ordering
	^ ordering ifNil: [ordering := true]! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 08:42'!
precondition
	^ precondition ifNil: [precondition := [true]].! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 08:43'!
precondition: aValuable
	precondition := aValuable! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 12/3/2009 16:08'!
realTarget
	^ target isSymbol ifTrue: [Smalltalk at: target ifAbsent: []] ifFalse: [target]! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 12/3/2009 16:09'!
receiver
	^ self targetSelector ifNil: [self realTarget] ifNotNil: [self realTarget perform: self targetSelector]! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 12/2/2009 16:40'!
target
	^ target! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 21:15'!
target: anObject
	target := anObject! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 21:15'!
targetSelector
	^ targetSelector! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 21:16'!
targetSelector: aSelector
	targetSelector := aSelector! !

!PragmaSetting methodsFor: 'reliability' stamp: 'AlainPlantec 11/24/2009 15:26'!
testIt
	"nothing to be done here"
	^ (((name isKindOf: String) or: [name isBlock or: [name isMessageSend]])
			and: [description isNil
					or: [description isKindOf: String]])
		and: [order isNil 
				or: [order isKindOf: Number]]! !

PragmaSetting subclass: #SystemSettingNode
	instanceVariableNames: 'dialog allowedInStyle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!SystemSettingNode commentStamp: 'alain.plantec 4/7/2009 23:04' prior: 0!
SystemSettingNode is the root class of all setting classes for preference settings. A SystemSettingNode can be instanciated. Such a node don't holds any value but is used as a named node in order to organize the preference tree. A Setting node can be associated with a dialog symbol which is the name of a dialog class that responds to the #open message. While browing a setting with a dialog, the browser shows a button which, when pressed, open a dialog which is supposed to present a cool and specific interface for some setting input (as an example, for the input of children settings of the node for which the dialog attribute is set). See SettingManager comment for more explanations.

Instance Variables
	dialog:		<Symbol>

!

SystemSettingNode subclass: #AbstractSettingDeclaration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!AbstractSettingDeclaration commentStamp: 'alain.plantec 4/8/2009 13:07' prior: 0!
An AbstractSettingValue is a setting which holds a real value for a setting. See subclasses comments and SettingManager comment for more explanations. For editable text fields, one can set the ghostHelp instance variable to an helpful small text that will be displayed over the textfield when empty.

Instance Variables
	realValue:		<Object>
	ghostHelp:		<String>

realValue 
	- It is the real value hold by the setting. This value is read-only and is get by sending #value to the setting.

ghostHelp
	- a help text displayed as a textfield background
!

!AbstractSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 11/28/2009 12:43'!
chooseFilePath
	| result |
	result := UITheme current fileOpenIn: World title: 'Choose a file' extensions: nil path: nil preview: true.
	result 
		ifNotNil: [
			self realValue: result name. 
			result close]! !

!AbstractSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 11/25/2009 08:30'!
fontButtonLabel
	| emphases |
	emphases := IdentityDictionary new at: nil put: 'Regular' translated;
				 at: 0 put: 'Regular' translated;
				 at: 1 put: 'Bold' translated;
				 at: 2 put: 'Italic' translated;
				 at: 4 put: 'Underlined' translated;
				 at: 8 put: 'Narrow' translated; 
				 at: 16 put: 'StruckOut' translated;
				 yourself.
	^ StringMorph contents: self realValue familyName , ' '
			, (emphases
					at: self realValue emphasis
					ifAbsent: ['']) , ' ' , self realValue pointSize asString font: self realValue! !

!AbstractSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 11/25/2009 08:30'!
getFont
	^ FontChooser
		openWithWindowTitle: 'Font for ' , self name
		for: self
		setSelector: #realValue:
		getSelector: #realValue ! !

!AbstractSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 12/3/2009 06:35'!
inputWidget
	"return the default widget for the input a the setting"
	| inputWidget xtraDialogWidget | 
	xtraDialogWidget := super inputWidget.
	inputWidget :=  self localInputWidgetSelector ifNotNil: [:localSel | self perform: localSel].
	(inputWidget isNil and: [self typeClass notNil])
		ifTrue: [inputWidget := (self inputWidgetSelectorInClass: self typeClass)
			ifNotNil: [:selector | self typeClass perform: selector with: self]].
	inputWidget
		ifNotNil: [(inputWidget respondsTo: #model:) 
			ifTrue: [inputWidget model: self]]. 
	xtraDialogWidget 
		ifNotNil: [inputWidget := inputWidget ifNil: [xtraDialogWidget] 
			ifNotNil: [UITheme current newRowIn: World for: {inputWidget. xtraDialogWidget}]].
	^ inputWidget ! !

!AbstractSettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 9/18/2009 23:17'!
inputWidgetForBoolean
	^ UITheme current
			newCheckboxIn: World
			for: self
			getSelected: #realValue
			setSelected: #realValue:
			getEnabled: #enabled
			label: '' 
			help: nil! !

!AbstractSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 11/12/2009 17:59'!
inputWidgetForColor
	^ (UITheme current
		newColorChooserIn: World
		for: self
		getColor: #realValue
		setColor: #realValue:
		getEnabled: #enabled 
		help: 'Choose a color') minWidth: 150; width: 150; yourself! !

!AbstractSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 12/3/2009 07:40'!
inputWidgetForFilePath
	^ UITheme current newRowIn: World for: {
					(EditableDropListMorph
						on: self
						list: #list
						selected: #index
						changeSelected: #index:
						useIndex: true 
						addToList: #addToList:
						class: String
						getEnabled: #enabled
						default: self defaultValue)
						ghostText: self ghostHelp;
						width: 450;
						wantsFrameAdornments: true;
						yourself.
					(UITheme current
						newButtonIn: World
						for: self
						getState: nil
						action: #chooseFilePath
						arguments: nil
						getEnabled: nil
						label:  (AlphaImageMorph new image: MenuIcons smallOpenIcon)
						help: 'Open file chooser dialog' translated)
					}
					! !

!AbstractSettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/7/2009 13:04'!
inputWidgetForFont
	^ (UITheme current
		newButtonIn: World
		for: self
		getState: nil 
		action: #getFont
		arguments: {}
		getEnabled: #enabled
		getLabel: #fontButtonLabel
		help: 'Choose a font ...' translated) cornerStyle: #square
! !

!AbstractSettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/4/2009 11:05'!
inputWidgetForNumber
	^ self inputWidgetForString width: 200.
! !

!AbstractSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 12/3/2009 07:39'!
inputWidgetForPassword
	| widget |
	widget := UITheme current
				newTextEntryIn: World
				for: self
				get: #realValue
				set: #realValue:
				class: String
				getEnabled: #enabled
				help: nil.
	widget
		wantsFrameAdornments: true;
		hResizing: #rigid;
		width: 450; 
		font: (StrikeFont passwordFontSize: UITheme current textFont pointSize).
	^ widget! !

!AbstractSettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/21/2009 09:49'!
inputWidgetForPoint
	^ self inputWidgetForString width: 200.
! !

!AbstractSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 12/3/2009 07:38'!
inputWidgetForString
	| widget |
	widget := EditableDropListMorph
				on: self
				list: #list
				selected: #index
				changeSelected: #index:
				useIndex: true 
				addToList: #addToList:
				class: (Smalltalk at: self type)
				getEnabled: #enabled
				default: self defaultValue.
	widget ghostText: self ghostHelp.
	widget contentMorph wantsFrameAdornments: true.
	widget width: 450.
	^ widget! !

!AbstractSettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/6/2009 21:51'!
inputWidgetSelectorInClass: aClass 
	| selector |
	^ (aClass respondsTo: (selector := #settingInputWidgetForNode:))
		ifTrue: [selector] ! !

!AbstractSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 11/28/2009 12:58'!
localInputWidgetSelector
	| imSel |
	^ (self respondsTo: (imSel := ('inputWidgetFor' , self type) asSymbol)) ifTrue: [imSel]! !

!AbstractSettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/4/2009 11:06'!
typeClass
	^ Smalltalk at: self type ifAbsent: []
! !

AbstractSettingDeclaration subclass: #SettingDeclaration
	instanceVariableNames: 'getSelector setSelector type default ghostHelp'
	classVariableNames: 'ValueListCache'
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!SettingDeclaration commentStamp: 'alain.plantec 4/7/2009 23:04' prior: 0!
A SettingValue is an handler for a writtable setting value. 
Its main responsibility is allow real value changing and to hold descriptive data about the setting. When the real value is changed, all declared listeners are notified. The standard event mechanism is used for that purpose. See #value: method which is call in order to change a setting value. Whatever object can declare its interest in the real value changes by sending #whenChangedSend:to: to a setting. See notification protocol.

For convenience, my olds values are registered in a list. This list is used by the SystemSettingBrowser in order to easily retrieve previous values.

The type instance variable is a Symbol. It is used by the SystemSettingBrowser in order to build the input widget of a setting.
It can be the name of the class or the name of a superclass of the value. In that case, the input widget is built by #settingInputWidgetForNode: implemented by the class which name is the value of the type instance variable. As an example, the input widget for a Boolean is built by Boolean class>>settingInputWidgetForNode:.

Type value is not limited to be a class name. It can also be whatever symbol. In that case, the selector corresponding to the message to send to the setting in order to build the inputWidget is built by SettingValue>>localInputWidgetSelector. If the type instance variable is not set, then it is dynamically set to the class name of the value. 

See SettingManager comment for more explanations.

Instance Variables
	type:			<Symbol>
	default:		<anObject>
	list:			<Collection>
!

SettingDeclaration subclass: #MultipleSettingDeclaration
	instanceVariableNames: 'domainValues getter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

MultipleSettingDeclaration subclass: #CheckListSettingDeclaration
	instanceVariableNames: 'choicesList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!CheckListSettingDeclaration commentStamp: 'AlainPlantec 11/26/2009 14:16' prior: 0!
A CheckListSettingDeclaration is a setting for which the value domain is a list. Each element of the list is an instance of FixedSettingValue. If domainValues is set, then the list of valid values is constant (initialized at declaration time). Instead, if getter is set, then the setting list is always dynamically computed. See SettingManager comment for more explanations. 


Instance Variables
	domainValues:		<Collection>
	getter:			<MessageSend or Block>

domainValues
	- nil if getter is set, The collection of FixedSettingValue which declares all valid values for the setting if getter is not set

getter
	- nil if domainValues is set, a valuable which return the domain values if domainValues is not set
!

!CheckListSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 12/2/2009 11:54'!
choicesList
	^ choicesList ifNil: [choicesList := SettingCheckListModel new settingDeclaration: self].
! !

!CheckListSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 11/25/2009 22:18'!
inputWidget
	^ self choicesList listMorph width: (self maxNameWidthForFont: UITheme current textFont) + 50
! !

MultipleSettingDeclaration subclass: #ListSettingDeclaration
	instanceVariableNames: 'choicesList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!ListSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 12/2/2009 15:40'!
choicesList
	^ choicesList ifNil: [choicesList := SettingListModel new settingDeclaration: self].
! !

!ListSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 12/2/2009 17:05'!
inputWidget
	^ self choicesList listMorph 
! !

!MultipleSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 11/25/2009 22:09'!
children
	^ self domainValues! !

!MultipleSettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 11/30/2009 14:30'!
domainValues
	^ getter
		ifNil: [domainValues ifNil: [domainValues := OrderedCollection new]]
		ifNotNil: [getter value asOrderedCollection collect: [:v | v settingFixedDomainValueNodeFrom: self]]! !

!MultipleSettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 22:09'!
domainValues: aCollection 
	domainValues := aCollection asArray collect: [ :v | v settingFixedDomainValueNodeFrom: self]! !

!MultipleSettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 22:09'!
domainValuesGetter: aValuable 
	self getter: aValuable! !

!MultipleSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 11/25/2009 22:09'!
domainValuesLabels
	^ self domainValues
		collect: [:f | f name]! !

!MultipleSettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 22:09'!
getter: aValuable 
	getter := aValuable! !

!MultipleSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 11/25/2009 22:09'!
hasEditableList
	^ false! !

!MultipleSettingDeclaration methodsFor: 'reliability' stamp: 'AlainPlantec 12/2/2009 17:04'!
testIt
	^ super testIt
		and: [self domainValues isCollection
				and: [self domainValues notEmpty
						and: [(self domainValues
								allSatisfy: [:v | v isKindOf: SettingDeclaration]) and: [self realValue isNil or: [(self domainValues collect: [:f | f realValue]) includes: self realValue]]]]]! !

MultipleSettingDeclaration subclass: #PickOneSettingDeclaration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!PickOneSettingDeclaration commentStamp: 'AlainPlantec 11/26/2009 14:16' prior: 0!
A CheckListSettingDeclaration is a setting for which the value domain is a list. Each element of the list is an instance of FixedSettingValue. If domainValues is set, then the list of valid values is constant (initialized at declaration time). Instead, if getter is set, then the setting list is always dynamically computed. See SettingManager comment for more explanations. 


Instance Variables
	domainValues:		<Collection>
	getter:			<MessageSend or Block>

domainValues
	- nil if getter is set, The collection of FixedSettingValue which declares all valid values for the setting if getter is not set

getter
	- nil if domainValues is set, a valuable which return the domain values if domainValues is not set
!

!PickOneSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 11/30/2009 14:23'!
chooseValue
	| chosen |
	chosen := UIManager default
				chooseFrom: self domainValuesLabels
				values: self domainValues
				title: self label translated, ' choices' translated.
	chosen
		ifNotNil: [self realValue: chosen realValue]! !

!PickOneSettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 10/17/2009 23:47'!
content
	^ (self domainValues
		detect: [:v | v realValue = self realValue]
		ifNone: [^ 'nil']) name! !

!PickOneSettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 10/17/2009 23:44'!
index
	self realValue ifNil: [self realValue: self default].
	^ self domainValues indexOf: (self domainValues detect: [:dv | dv realValue = self realValue] ifNone: [^ 0])! !

!PickOneSettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 10/17/2009 23:39'!
index: anInteger
	self realValue: (self domainValues at: anInteger) realValue.
! !

!PickOneSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 12/2/2009 14:03'!
inputWidget
	| widget font row |
	font := UITheme current textFont.
	getter
		ifNil: [row := UITheme current newRowIn: World for: {
				widget := (UITheme current
						newDropListIn: World
						for: self
						list: #domainValuesLabels
						getSelected: #index
						setSelected: #index:
						getEnabled: #enabled
						useIndex: true
						help: self description)
						extent: 1 @ 30}.
					font := widget font]
		ifNotNil: [row := UITheme current newRowIn: World for: {
					widget := (UITheme current
						newTextEntryIn: World
						for: self
						get: #content
						set: nil
						class: String
						getEnabled: #enabled
						help: nil) lock; yourself.
					(UITheme current
						newButtonIn: World
						for: self
						getState: nil
						action: #chooseValue
						arguments: {}
						getEnabled: #enabled
						getLabel: nil
						help: 'Choose a value for ' translated , self name translated) label: '...';
						 cornerStyle: #square;
						 yourself}.
					row cellInset: 0].
	widget hResizing: #rigid.
	widget width: (self maxNameWidthForFont: font) + 50.
	^ row! !

SettingDeclaration subclass: #RangeSettingDeclaration
	instanceVariableNames: 'range'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!RangeSettingDeclaration commentStamp: 'alain.plantec 4/7/2009 23:03' prior: 0!
A RangeSettingValue is a setting for which the value domain is an interval.  See SettingManager comment for more explanations.

Instance Variables
	range:		<Interval>

range
	- The interval which define the value domain
!

!RangeSettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/8/2009 16:57'!
hasEditableList
	^ false! !

!RangeSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 12/3/2009 07:40'!
inputWidget
	^ (UITheme current newRowIn: World for: {(UITheme current
							newTextEntryIn: World 
							for: self
							get: #realValue
							set: #realValue:
							class: (Smalltalk at: self type)
							getEnabled: #enabled
							help: nil) hResizing: #rigid;
							width: 80;
							wantsFrameAdornments: true;
							yourself. 
						(PluggableSliderMorph new max: self range last;
							 min: self range first;
							 quantum: self range increment;
							on: self
							getValue: #realValue
							setValue: #realValue:) hResizing: #spaceFill;
							 vResizing: #spaceFIll;
							 setBalloonText: self description;
							 minWidth: 300;
							 yourself}) 
				cellInset: 10;
				yourself! !

!RangeSettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 3/12/2009 16:19'!
range
	^ range ! !

!RangeSettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 3/3/2009 09:38'!
range: anInterval
	range := anInterval! !

!RangeSettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 12/14/2009 18:45'!
realValue: aValue
	aValue
		ifNil: [self receiver perform: self setSelector with: nil]
		ifNotNil: [self receiver perform: self setSelector with: ((aValue max: self range first) min: self range last)].
	self triggerEvent: self privateChangeEvent with: self
	! !

!RangeSettingDeclaration methodsFor: 'reliability' stamp: 'alain.plantec 4/7/2009 12:25'!
testIt
	^ super testIt
		and: [(self range isKindOf: Interval)
				and: [self value isNil
						or: [self range includes: self value]]] ! !

!SettingDeclaration class methodsFor: 'icon accessing' stamp: 'alain.plantec 4/9/2009 00:15'!
nullifyForm
	^ (Form
	extent: 16@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 463732736 4285815129 4285815129 4285815129 4285815129 4285815129 2292449280 463732736 0 0 0 0 0 0 0 1688469504 4285815129 4278190080 4278190080 4278190080 4278190080 4278190080 4280091395 4285815129 1688469504 0 0 0 0 0 1688469504 4285815129 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4285815129 1688469504 0 0 0 463732736 4285815129 4278190080 4294967295 4294967295 4278190080 4278190080 4278190080 4278190080 4294967295 4294967295 4278190080 4285815129 463732736 0 0 4285815129 4278190080 4278190080 4294967295 4294967295 4294967295 4278190080 4278190080 4294967295 4294967295 4294967295 4278190080 4285815129 4285815129 0 0 4285815129 4278190080 4278190080 4278190080 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190080 4278190080 4278190080 4285815129 0 0 4285815129 4278190080 4278190080 4278190080 4278190080 4294967295 4294967295 4294967295 4294967295 4278190080 4278190080 4278190080 4278190080 4285815129 0 0 4285815129 4278190080 4278190080 4278190080 4278190080 4294967295 4294967295 4294967295 4294967295 4278190080 4278190080 4278190080 4278190080 4285815129 0 0 4285815129 4278190080 4278190080 4278190080 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190080 4278190080 4278190080 4285815129 0 0 2292449280 4281927174 4280025345 4294967295 4294967295 4294967295 4278190080 4278190080 4294967295 4294967295 4294967295 4278190080 4283696903 4285815129 0 0 463732736 4285815129 4278190080 4294967295 4294967295 4278190080 4278190080 4278190080 4278190080 4294967295 4294967295 4278190080 4285815129 463732736 0 0 0 1688469504 4285815129 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4285815129 1688469504 0 0 0 0 0 1688469504 4285815129 4285815129 4278190080 4278190080 4278190080 4278190080 4283696646 4285815129 1688469504 0 0 0 0 0 0 0 463732736 2292449280 4285815129 4285815129 4285815129 4285815129 2292449280 463732736 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!SettingDeclaration class methodsFor: 'icon accessing' stamp: 'alain.plantec 4/8/2009 17:40'!
smallCautionForm
	^ (Form
	extent: 16@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 463732736 2292449280 3517186048 4154720256 4154720256 3517186048 2292449280 463732736 0 0 0 0 0 0 0 1688469504 4137943040 4292614939 4293600292 4293534756 4293534499 4293402913 4292483352 4137943040 1688469504 0 0 0 0 0 1688469504 4290185224 4293600292 4292284175 4291428866 4291166208 4291100672 4291297794 4292087053 4293271070 4290184967 1688469504 0 0 0 463732736 4137943040 4293534756 4291823367 4291231744 4291166208 4294967295 4294967295 4290969600 4290969600 4291429637 4293073948 4137943040 463732736 0 0 2292449280 4292614682 4292284175 4291231744 4291035136 4291035136 4294967295 4294967295 4291035136 4291035136 4290838528 4291824395 4292351253 2292449280 0 0 3517186048 4293468963 4291363330 4291166208 4291035136 4291035136 4294967295 4294967295 4291035136 4291035136 4290707456 4290838785 4292942105 3517186048 0 0 4154720256 4293534242 4291166208 4291100672 4291035136 4291035136 4294967295 4294967295 4291035136 4290707456 4290641920 4290641920 4292942104 4154720256 0 0 4154720256 4293468449 4291035136 4291035136 4291035136 4291035136 4291100672 4291100672 4291035136 4290641920 4290576384 4290510848 4292876056 4154720256 0 0 3517186048 4293271328 4291166722 4290969600 4291035136 4291035136 4291035136 4291035136 4291035136 4291035136 4290510848 4290576641 4292744726 3517186048 0 0 2292449280 4292417303 4291955981 4290838528 4291035136 4291035136 4294967295 4294967295 4291035136 4291035136 4290445312 4291430665 4292088338 2292449280 0 0 463732736 4137943040 4293139484 4291298565 4290707456 4290641920 4294967295 4294967295 4290510848 4290379776 4290905092 4292678933 4137943040 463732736 0 0 0 1688469504 4290184967 4293007898 4291693323 4290707713 4290510848 4290445312 4290511105 4291365129 4292678932 4290053638 1688469504 0 0 0 0 0 1688469504 4137943040 4292219924 4292876311 4292876055 4292810518 4292744726 4292088081 4137943040 1688469504 0 0 0 0 0 0 0 463732736 2292449280 3517186048 4154720256 4154720256 3517186048 2292449280 463732736 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!SettingDeclaration class methodsFor: 'cache accessing' stamp: 'alain.plantec 9/18/2009 09:57'!
valueListCache
	^ ValueListCache ifNil: [ValueListCache := WeakKeyDictionary new]! !

!SettingDeclaration class methodsFor: 'cache accessing' stamp: 'AlainPlantec 11/26/2009 21:21'!
valueListFor: aSettingValue
	| targetEntry |
	targetEntry := self valueListCache at: aSettingValue receiver ifAbsentPut: [IdentityDictionary new].
	^ targetEntry at: aSettingValue getSelector ifAbsentPut: [OrderedCollection new].! !

!SettingDeclaration methodsFor: 'comparing' stamp: 'AlainPlantec 12/2/2009 16:44'!
= other
	self class = other class
		ifFalse: [^ false].
	self target == other target ifFalse: [^ false].
	self targetSelector = other targetSelector ifFalse: [^ false].
	self getSelector = other getSelector ifFalse: [^ false].
	self setSelector = other setSelector ifFalse: [^ false].
	^ true
	
! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/9/2009 09:41'!
addToList: anItem
	(self list includes: anItem)
		ifFalse: [self list size > self maxKept
				ifTrue: [self list removeFirst].
			self list add: anItem.
			self changed: #list]! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 3/11/2009 19:40'!
default
	^ default ! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 9/18/2009 09:13'!
default: anObject 
	"initialize the default value"
	default := anObject.
! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 12/5/2009 14:40'!
defaultIcon
	^ (self type = #LogicalFont or: [self realValue isKindOf: AbstractFont])
		ifTrue: [MenuIcons smallFontsIcon]
		ifFalse: [MenuIcons smallPaintIcon]! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 3/4/2009 11:48'!
defaultValue
	^ default value! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 9/19/2009 09:18'!
emptyList
	self list removeAll.
	self value ifNotNil: [self addToList: self realValue].! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 12/2/2009 17:01'!
fixedDomainValueNodeForAssociation: anAssociation 
	| s |
	^ (s := (SettingDeclaration new name: anAssociation key))
		target: s;
		selector: #default;
		default: anAssociation value! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 12/2/2009 17:01'!
fixedDomainValueNodeForObject: anObject 
	| s |
	^ (s := (SettingDeclaration new name: anObject asString))
		target: s;
		selector: #default;
		default: anObject! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 11/23/2009 22:35'!
getSelector
	^ getSelector ifNil: [self name]! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 9/18/2009 23:07'!
getSelector: aSymbol
	getSelector := aSymbol! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 9/18/2009 23:52'!
ghostHelp
	^ ghostHelp ! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 9/18/2009 23:52'!
ghostHelp: aString
	ghostHelp := aString! !

!SettingDeclaration methodsFor: 'testing' stamp: 'alain.plantec 4/8/2009 16:59'!
hasDefault
	^ true! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/8/2009 16:57'!
hasEditableList
	^ true! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/8/2009 16:50'!
hasPrivateListener
	^ self hasActionForEvent: self privateChangeEvent! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 08:22'!
hasValue
	^ true! !

!SettingDeclaration methodsFor: 'comparing' stamp: 'AlainPlantec 12/13/2009 08:55'!
hash
	"hash is re-implemented because #= is re-implemented"
	^ self target hash
		bitXor: (self targetSelector hash
				bitXor: (self getSelector hash bitXor: self setSelector hash)) ! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 9/18/2009 23:20'!
index
	^ self list
		indexOf: self realValue
		ifAbsent: [self realValue
				ifNil: [0]
				ifNotNil: [self addToList: self realValue.
					self list size]]! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 9/18/2009 09:44'!
index: anInteger 
	self realValue: (self list at: anInteger)! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 5/20/2009 12:24'!
inputMorphFor: aContainer
	^ (super inputMorphFor: aContainer)
		ifNotNil: [:im |			
				self whenPrivateChangedSend: #settingValueChanged: to: aContainer model.
				self whenPrivateChangedSend: #innerWidgetChanged to: aContainer.
				im]! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 9/18/2009 23:10'!
list
	^ self class valueListFor: self! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 9/17/2009 21:20'!
listenersForEvent: anEvent
	| listeners actionSequence |	
	listeners := Set new.	
	actionSequence := self actionMap at: anEvent ifAbsent: [].	
	actionSequence ifNotNil: [
		actionSequence isCollection	 
			ifTrue: [actionSequence do: [:oneAction | 
					oneAction receiver ifNotNil: [:r | listeners add: r]]]
			ifFalse: [listeners add: actionSequence receiver]].
	^ listeners! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/6/2009 21:54'!
maxKept
	"maximum number of old values which are kept in
	list instance variable"
	^ 5! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 11/25/2009 21:35'!
maxNameWidthForFont: aFont 
	| max |
	max := 0.
	self domainValuesLabels
		do: [:v | max := max max: (aFont widthOfStringOrText: v)].
	^ max ! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 4/8/2009 15:59'!
privateChangeEvent
	^ #privateSettingValueChanged! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/8/2009 16:10'!
privateForget: aReceiver 
	"do not notify aReceiver anymore"
	self removeActionsWithReceiver: aReceiver forEvent: self privateChangeEvent! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/8/2009 16:50'!
privateForget: aReceiver selector: aSelector 
	"Private"
	self
		removeActionsSatisfying: [:action | action receiver == aReceiver
				and: [action selector = aSelector]]
		forEvent: self privateChangeEvent! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/8/2009 16:35'!
privateListeners
	^ self listenersForEvent: self privateChangeEvent! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 21:20'!
realValue
	"Answer the value of realValue"

	^ (self receiver perform: self getSelector) 
		ifNil: [self setToDefault. 
			self receiver perform: self getSelector]! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 21:20'!
realValue: anObject
	"Set the value of realValue"
	self receiver perform: self setSelector with: anObject.
	self triggerEvent: self privateChangeEvent with: self.! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 11/23/2009 13:49'!
selector: aSymbol
	self getSelector: aSymbol.
	self setSelector: (aSymbol, ':') asSymbol.! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 11/23/2009 22:36'!
setSelector
	^ setSelector ifNil: [self getSelector ifNotNil: [:gs | (gs, ':') asSymbol]]! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 9/18/2009 23:07'!
setSelector: aSymbol
	setSelector := aSymbol! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 9/18/2009 09:23'!
setToDefault
	self realValue: self defaultValue.
! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 9/18/2009 09:24'!
type
	"Answer the value of type"

	^ type ifNil: [type := self realValue class name]! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 3/11/2009 18:22'!
type: anObject
	"Set the value of type"

	type := anObject! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/8/2009 15:59'!
whenPrivateChangedSend: zeroOrOneArgSelector to: aSubscriber 
	"private, use #whenChangedSend:to: instead"
	self
		when: self privateChangeEvent
		send: zeroOrOneArgSelector
		to: aSubscriber! !

SystemSettingNode subclass: #SystemSettingLauncher
	instanceVariableNames: 'script'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!SystemSettingLauncher methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 13:44'!
defaultIcon
	^ MenuIcons smallDoItIcon! !

!SystemSettingLauncher methodsFor: 'accessing' stamp: 'AlainPlantec 12/12/2009 10:10'!
inputWidget
	^ (UITheme current
				newButtonIn: World 
				for: self
				getState: nil
				action: #launch
				arguments: {}
				getEnabled: nil
				getLabel: nil
				help: self description)
		 		label: (UITheme current newRowIn: World for: {AlphaImageMorph new image: MenuIcons smallRedoIcon. UITheme current buttonLabelForText: 'Launch' translated});
		 		yourself.! !

!SystemSettingLauncher methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 14:22'!
launch
	self script 
			ifNotNil: [:s | s isSymbol 
				ifTrue: [s numArgs = 0 
					ifTrue: [self receiver perform: s]
					ifFalse: [self receiver perform: s with: self]]
				ifFalse: [s numArgs = 0 
					ifTrue: [s value]
					ifFalse: [s value: self]]]! !

!SystemSettingLauncher methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 13:22'!
script
	^ script ifNil: [script := []]! !

!SystemSettingLauncher methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 14:19'!
script: aValuableOrSymbol
	script := aValuableOrSymbol! !

!SystemSettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 14:31'!
allowedInStyle
	^ allowedInStyle ifNil: [allowedInStyle := self hasValue]! !

!SystemSettingNode methodsFor: 'user interface' stamp: 'alain.plantec 4/6/2009 18:59'!
children
	^#()! !

!SystemSettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 08:25'!
defaultIcon
	^ MenuIcons smallConfigurationIcon! !

!SystemSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 20:42'!
dialog
	^ dialog! !

!SystemSettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/4/2009 21:35'!
dialog: aValuable
	dialog := aValuable! !

!SystemSettingNode methodsFor: 'testing' stamp: 'alain.plantec 4/8/2009 16:59'!
hasDefault
	^ false! !

!SystemSettingNode methodsFor: 'user interface' stamp: 'alain.plantec 4/8/2009 16:57'!
hasEditableList
	^ false! !

!SystemSettingNode methodsFor: 'testing' stamp: 'alain.plantec 3/24/2009 20:52'!
hasValue
	^ false! !

!SystemSettingNode methodsFor: 'user interface' stamp: 'AlainPlantec 12/4/2009 21:38'!
inputWidget
	^ self dialog 
			ifNotNil: [:d | 
				d numArgs = 0 
					ifTrue: [d value]
					ifFalse: [d value: self]]! !

!SystemSettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/3/2009 16:21'!
notInStyle
	allowedInStyle := false! !

!SystemSettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 08:20'!
realValue
	^ self subclassResponsibility ! !

!SystemSettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 08:20'!
realValue: aValue
	self subclassResponsibility ! !

Object subclass: #SettingFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Filter'!

!SettingFilter commentStamp: 'alain.plantec 4/8/2009 12:51' prior: 0!
A SettingFilter is a filter wich is used by a SettingBrowser in order to select which nodes of the setting trees are to be shown. A SettingFilter subclass must redefine the #keepHandler: method which return true if the argument handler is to be kept.

Instance Variables
!

!SettingFilter methodsFor: 'filtering' stamp: 'alain.plantec 9/18/2009 23:46'!
keepSettingTreeNode: aSettingNode 
	^ false! !

SettingFilter subclass: #SettingPackageFilter
	instanceVariableNames: 'packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Filter'!

!SettingPackageFilter commentStamp: 'alain.plantec 4/8/2009 12:58' prior: 0!
A SettingPackageFilter is SettingFilter which keeps only handlers with a pragma which defining method belongs to at least one of the given list of packages.

Instance Variables
	packages:		<Collection>

packages
	- The collection of PackageInfo the filter is currently using!

!SettingPackageFilter methodsFor: 'filtering' stamp: 'AlainPlantec 11/27/2009 10:28'!
keepSettingTreeNode: aSettingNode 
	| rp |
	^ (rp := aSettingNode receiverPackage) notNil and: [self packages includes: rp]! !

!SettingPackageFilter methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 23:00'!
packages
	"Answer the value of packages"

	^ packages! !

!SettingPackageFilter methodsFor: 'accessing' stamp: 'alain.plantec 4/8/2009 12:55'!
packages: aCollectionOfPackageInfo
	"Set the value of packages"

	packages := aCollectionOfPackageInfo
! !

SettingFilter subclass: #SettingRegexpFilter
	instanceVariableNames: 'regexp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Filter'!

!SettingRegexpFilter commentStamp: 'alain.plantec 4/8/2009 13:02' prior: 0!
A SettingRegexpFilter is SettingFilter which makes use of a regular expression in order to keep or not a SettingHandler.

Instance Variables
	regexp:		<String>

regexp
	- a regular expression string
!

!SettingRegexpFilter methodsFor: 'filtering' stamp: 'alain.plantec 9/18/2009 23:43'!
keepSettingDeclaration: aSettingDeclaration
	^ ({aSettingDeclaration name. aSettingDeclaration description}
				collect: [:e | e ifNil: ['']])
				anySatisfy: [:token | token substrings anySatisfy: [:sub | sub matchesRegexIgnoringCase: self regexp]]
! !

!SettingRegexpFilter methodsFor: 'filtering' stamp: 'alain.plantec 9/18/2009 23:46'!
keepSettingTreeNode: aSettingNode 
	^ (({aSettingNode methodClass name. aSettingNode selector}
			collect: [:e | e ifNil: ['']])
			anySatisfy: [:token | token substrings anySatisfy: [:sub | sub matchesRegexIgnoringCase: self regexp]])
		or: [self keepSettingDeclaration: aSettingNode settingDeclaration] ! !

!SettingRegexpFilter methodsFor: 'accessing' stamp: 'alain.plantec 4/7/2009 23:52'!
regexp
	"Answer the value of regexp"

	^ regexp! !

!SettingRegexpFilter methodsFor: 'accessing' stamp: 'alain.plantec 4/7/2009 23:52'!
regexp: anObject
	"Set the value of regexp"

	regexp := anObject! !

SettingFilter subclass: #SettingTokenFilter
	instanceVariableNames: 'token'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Filter'!

!SettingTokenFilter commentStamp: 'alain.plantec 4/8/2009 13:03' prior: 0!
A SettingTokenFilter is SettingFilter which makes use of a token (substring) in order to keep or not a SettingHandler.


Instance Variables
	token:		<String>

!

!SettingTokenFilter methodsFor: 'filtering' stamp: 'alain.plantec 9/18/2009 23:45'!
keepSettingDeclaration: aSettingDeclaration
	^ (({aSettingDeclaration name asUppercase. aSettingDeclaration description asUppercase}
				collect: [:e | e ifNil: ['']])
				includesSubstringAnywhere: self token asUppercase)
! !

!SettingTokenFilter methodsFor: 'filtering' stamp: 'alain.plantec 9/18/2009 23:46'!
keepSettingTreeNode: aSettingNode 
	^ (({aSettingNode methodClass name asUppercase. aSettingNode selector asUppercase}
			collect: [:e | e
					ifNil: ['']])
			includesSubstringAnywhere: self token asUppercase)
		or: [self keepSettingDeclaration: aSettingNode settingDeclaration]! !

!SettingTokenFilter methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 22:51'!
token
	"Answer the value of token"

	^ token! !

!SettingTokenFilter methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 22:51'!
token: aString
	"Set the value of token"

	token := aString! !

Object subclass: #SettingManager
	instanceVariableNames: ''
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!SettingManager commentStamp: 'alain.plantec 4/21/2009 15:22' prior: 0!
System settings are used to manage useful global parameters. A system setting is an instance of SystemSettingNode or of one of its subclasses. SettingManager is a facade for system setting instanciation.

A setting is declared by a class method with a simple pragma. The pragma allows the SystemSettingBrowser to dynamically discover current settings. The default system setting pragma is <setting>. 

The important point is that a setting must be package specific. It means that each package is responsible for the declaring of its own settings. For a particular package, specific settings are declared by one or several of its classes. The consequence is that when the package is loaded, then its settings are automatically loaded and that when a package is unloaded, then its settings are automatically unloaded.

Basically, settings are of two main kinds: setting nodes and settings with value. 
- A setting node don't hold any value. Such a setting is declared by a method which simply returns a SystemSettingNode instance. Any setting can declare any setting node as its parent.
- A setting with value is an instance of SettingValue or of one of its subclasses. Such a setting holds a useful global system parameter and is made persistent: it is stored in a class variable which is initialized by the method that declares the setting.

1 DECLARING A SETTING NODE

All System settings are organized in trees. Each tree root is a setting with no parent (parent set to nil). Whatever setting can be a root. If a root doesn't need to keep any value, then it can be an instance of SystemSettingNode. Such a setting is instanciated with: #SettingManager class>>newNode:. The argument is the name of the node. A setting node is mostly useful for the grouping of several related settings. The dialog instance variable can be set to the name of a dialog class. Then, the SystemSettingBrowser shows a button for this dialog: when pressed, the class which name is the dialog instance variable value receives the #open message. It can be useful in order to open a complex or handy dialog for the input of some settings.

The example below shows a root node named 'System' declared in a SystemSettings class.
------------------
SystemSettings class>>systemSettingNode
	<setting>
	^ (SettingManager newNode: 'System') description: 'All standard system settings'
------------------

The example below shows a the declaration of a subnode of systemSettingNode, it is declared in a UISettings class:
------------------
UISettings class>>UINode
	<setting>
	^ (SettingManager newNode: 'User interface') 
			description: 'Paramaters for the user interface'; 
			parent: #systemSettingNode
------------------
		
2 DECLARING SIMPLE VALUE SETTINGS

2.1 PRESENTATION
A simple value setting is a setting which value is a Boolean, a String, a Symbol, a Number, a Font or a Color. Such a setting is hold by a SettingValue which is instanciated with #SettingManager class>>newSetting:. The argument is the name of the setting.
If the setting has a default value, then, the setting is declared with the default value as below:
------------------
MyPackageSettings class>>mySetting
	<setting>
	^ MySetting 
		ifNil: [MySetting := (SettingManager newSetting: 'My setting name') 
											description: 'A useful description'; 
											default: aDefaultValue]
------------------
where:
- MyPackageSettings is a class of MyPackage package (a system setting is declared class side)
- mySetting is the getter for the setting
- MySetting is the name of the class variable which value is the setting (instance of SettingValue)
- 'My setting label' and 'A useful description' are respectively, the name and the description shown by the SystemSettingBrowser.
- aDefaultValue is the default value for the setting

If the setting doesn't have any default value (or if its default value is nil):
------------------
MyPackageSettings class>>mySetting
	<setting>
	^ MySetting 
		ifNil: [MySetting := (SettingManager newSetting: 'My setting name') 
											description: 'A useful description'; 
											type: aTypeSymbol]
------------------

aTypeSymbol is a symbol used by the setting browser in order to know how to build the input widget. By default, possible values are #Boolean, #String, #Symbol, #Integer, #Float, #Font or #Color. It can be of another value but in that case, the class which name is the type value should understand the #settingInputWidgetForNode: message.

Classically, a SettingValue is not a root: it is declared as a child of one or several nodes in order to ease its managing. 
------------------
MyPackageSettings class>>mySetting
	<setting>
	^ MySetting 
		ifNil: [MySetting := (SettingManager newSetting: 'My setting name') 
											description: 'A useful description'; 
											parent: aParentNodeSelector;
											type: aTypeSymbol]
------------------

aParentNodeSelector is a symbol which is the parent node method selector.

A setting node may have several parents:
------------------
MyPackageSettings class>>mySetting
	<setting>
	^ MySetting 
		ifNil: [MySetting := (SettingManager newSetting: 'My setting name') 
											description: 'A useful description'; 
											parent: firstParentNodeSelector;
											parent: secondParentNodeSelector;
											type: aTypeSymbol]
------------------
or
------------------
MyPackageSettings class>>mySetting
	<setting>
	^ MySetting 
		ifNil: [MySetting := (SettingManager newSetting: 'My setting name') 
											description: 'A useful description'; 
											parents: #(firstParentNodeSelector secondParentNodeSelector);
											type: aTypeSymbol]
------------------


2.2 SIMPLE VALUE SETTING EXAMPLES

2.2.1 Boolean settings
Definition of the boolean setting "newbyMode" with only a label and a default value:
------------------
MyClass class>>newbyMode
	<setting>
	^ NewbyMode ifNil: [NewbyMode := (SettingManager newSetting: 'Newby mode') default: false].
------------------
						
A description could be very helpful when using the SystemSettingBrowser: 			
------------------
MyClass class>>newbyMode
	<setting>
	^ NewbyMode ifNil: [NewbyMode := (SettingManager newSetting: 'Newby mode') 
			default: false; 
			description: 'the useful description goes here...'].
------------------

The default value is optional. If not present, the declaration must explicitly initialize the setting type:
------------------
MyClass class>>newbyMode
	<setting>
	^ NewbyMode ifNil: [NewbyMode := (SettingManager newSetting: 'Newby mode') 
			type: #Boolean; 
			description: 'the useful description goes here...'].
------------------

2.2.4 Color setting
Note that the default can be a valuable. Here, the default is given by a MessageSend instance:
------------------
MyClass class>>desktopColor
	<setting>
	^ DesktopColor
		ifNil: [DesktopColor := (SettingManager newSetting: 'Desktop color') 
					parent: #uiColors;
					description: 'The color used for the desktop background';
					default: (MessageSend receiver: Color selector: #green)]
------------------

You can also use a block for the default:
------------------
MyClass class>>desktopColor
	<setting>
	^ DesktopColor
		ifNil: [DesktopColor := (SettingManager newSetting: 'Desktop color') 
					parent: #uiColors;
					description: 'The color used for the desktop background';
					default: [Color green]]
------------------

2.2.5 Font setting
Here the default is an instance of LogicalFont:
------------------
MyClass class>>codeFont
	<setting>
	^ CodeFont
		ifNil: [CodeFont := (SettingManager newSetting: 'Code') description: 'The code font';
						 parent: #fontSettingNode;
						 default: (LogicalFont familyName: 'DejaVu Sans' 
												fallbackFamilyNames: nil 
												pointSize: 12 
												stretchValue: 5 
												weightValue: 400 
												slantValue: 0)]
------------------

The default can also be set with a MessageSend instance:
------------------
MyClass class>>codeFont
	<setting>
	^ CodeFont
		ifNil: [CodeFont := (SettingManager newSetting: 'Code') description: 'The code font';
						 parent: #fontSettingNode;
     				 default: (MessageSend receiver: self selector: #defaultStandardFont)]

MyClass class>>defaultStandardFont
	^ LogicalFont
		familyName: 'DejaVu Sans'
		fallbackFamilyNames: nil
		pointSize: 12
		stretchValue: 5
		weightValue: 400
		slantValue: 0
------------------

3 DECLARING A SETTING WITH FINITE SET OF VALUES

3.1 PRESENTATION
A setting can be defined so that its value is get from a restricted set of values. The setting is an instance of MultipleSettingValue. It is instanciated with #SettingManager class>>newMultiple:. The argument is the name of the setting. The collection of values from which a multiple setting takes its value is always a set of FixedSettingValue. A FixedSettingValue is created with #SettingManager class>>newFixed:.

Such a setting can be of two different kinds :
- if the valid value list is known at declaration time and is constant, then the list of values is set by sending the #domainValues: message to the setting. The argument is an array of fixed values. 

Such a setting can be declared as below:
------------------
MyPackageSettings class>>mySetting
	<setting>
	^ MySetting 
		ifNil: [MySetting := (SettingManager newMultiple: 'My setting name') 
						description: 'A useful description'; 
						default: aDefaultValue;
						domainValues: aListOfFixedSettingValues]
------------------
					
The default should be one of the valid values: a real value which is token from the list of possible values. 

- if the valid value list is not known at declaration time, then the list of possible values is dynamically computed by the SystemSettingBrowser by evaluating the block or the MessageSend stored as the getter instance variable value. The getter instance variable is set by sending the #domainValuesGetter: message to the setting.

Such a setting can be declared as below:
------------------
MyPackageSettings class>>mySetting
	<setting>
	^ MySetting 
		ifNil: [MySetting := (SettingManager newMultiple:'My setting name') 
						description: 'A useful description'; 
						default: aDefaultValue;
						domainValuesGetter: aBlockOrAMessageSend]
------------------
The argument of #domainValuesGetter: can be a block or a instance of MessageSend. This valuable takes no argument. 

3.2 EXAMPLES 

The declaration gives all possibles values for the setting. Each possible domain value is a fixed setting (read-only setting). Here is the example of #hintingSetting which value can be #Light, #Normal, #Full or #None:
------------------
MyClass class>>hintingSetting
	<setting>
	^ HintingSetting
		ifNil: [HintingSetting := (SettingManager newMultiple: 'Hinting')
						 description: 'Defines the glyph shapes' translated;
						 parent: #freeTypeSettingNode;
						 domainValues: {
							SettingManager newFixed value: #Light. 
							SettingManager newFixed value: #Normal. 
							SettingManager newFixed value: #Full. 
							SettingManager newFixed value: #None
						}].
------------------

In the case where domain values are of simple type, as Symbol for example, the shorter declaration given below can be used:		
------------------
MyClass class>>hintingSetting
	<setting>
	^ HintingSetting
		ifNil: [HintingSetting := (SettingManager newMultiple: 'Hinting')
						 description: 'Defines the glyph shapes' translated;
						 parent: #freeTypeSettingNode;
						 domainValues: {#Light. #Normal. #Full. #None}]
------------------

The value domain can also be made of a set of complex objects. The example below shows #themeSetting setting. The value domain is an array with two fixed settings, for UIThemeStandardSqueak and for UIThemeWatery2:
------------------
MyClass class>>themeSetting
	<setting>
	^ ThemeSetting
		ifNil: [ThemeSetting := (SettingManager newMultiple: 'UITheme')
						description: 'The theme to use for UI look and feel';
						parent: #uiSettingNode;
						type: #UITheme;
						default: UIThemeWatery2;
						domainValues: {
							(SettingManager newFixed: 'Standard Squeak') value: UIThemeStandardSqueak. 
							(SettingManager newFixed: 'Watery 2') description: 'Similar to a nice OS'; value: UIThemeWatery2}]
------------------

The shorter declaration given below can also be used. The domain values is a list of association. Each association key is used as the name of the fixed setting, and the corresponding association value is used as the value of the fixed setting:
------------------
MyClass class>>themeSetting
	<setting>
	^ ThemeSetting
		ifNil: [ThemeSetting := (SettingManager newMultiple: 'UI theme')
						 description: 'The theme to use for UI look and feel';
						 parent: #uiSettingNode;
						 type: #UITheme;
						 default: UIThemeWatery2;
						 domainValues: {'Standard' -> UIThemeStandardSqueak. 'Watery 2' -> UIThemeWatery2}]
------------------

Previous version has a serious drawback: the list of possible values is fixed, then the first time the setting is read, the list is definitively built. After its building, there is no way to update the list except by the reinitializing of the corresponding class variable (hard reset). 
Regarding the themeSetting example, the problem is that new instances of UITheme can be added in the system after the setting has been created and initialized. In order be able to take into account system dependent domain values, you can makes the list dynamically computed. A getter instance variable can be set to a block or to an instance of a MessageSend. Such a valuable is dynamically evaluated by the SystemSettingBrowser in order to get current and up-to-date list of valid values. Here is the themeSetting example revisited:

------------------
MyClass class>>themeSetting
	<setting>
	^ ThemeSetting
		ifNil: [ThemeSetting := (SettingManager newMultiple:'UI theme')
						parent: #uiSettingNode;
						default: UIThemeWatery2;
						domainValuesGetter: [UITheme allSubclasses collect: [:cls | SettingManager newFixed value: cls]]]
------------------

or with a much simpler version
------------------
MyClass class>>themeSetting
	<setting>
	^ ThemeSetting
		ifNil: [ThemeSetting := (SettingManager newMultiple:'UI theme')
						parent: #uiSettingNode;
						default: UIThemeWatery2;
						domainValuesGetter: [UITheme allSubclasses]]
------------------

4 DECLARING RANGE SETTING

4.1 PRESENTATION
A setting for which all possible values are given by a range is an instance of RangeSettingValue. Such a setting is instanciated with #SettingManager class>>newRange:. The argument is the name of the setting. The range is set by sending a #range: message to a setting. The argument is an Interval instance.

Such a setting can be declared as below:
------------------
MyPackageSettings class>>mySetting
	<setting>
	^ MySetting 
		ifNil: [MySetting := (SettingManager newRange: 'My setting name') 
						description: 'A useful description'; 
						default: aDefaultValue;
						range: anInterval]
------------------
The range is an instance of Interval. It is set by the #range: message and is evaluated by the SystemSettingBrowser when choosing a new value.
Note that the SystemSettingBrowser presents an input field and a slider. 

4.2 EXAMPLE

------------------
FontSettings class>>glyphContrast
	<setting>
	^ GlyphContrast
		ifNil: [GlyphContrast := (SettingManager newRange: 'Glyph contrast') 
						description: 'Change the contrast level for glyphs. This is an integer between 1 and 100';
						parent: #freeTypeSettingNode;
						default: 50;
						range: (1 to: 100)]
------------------

5 USING SPECIFIC DIALOG
For setting browsing and editing, it could be useful to use a specific dialog instead of SystemSettingBrowser simple input widgets. For that purpose, the dialog attribute can be set with the name of a dialog class. While browsing a setting with a dialog, the SystemSettingBrowser presents a button for the dialog opening. The only constraint is that the dialog class must understand the #open message.

For a node with children, it can be very useful in order to be able to use a cool dialog for the input of all children instead of being forced to input them one by one as it is the case with the SystemSettingrowser.

Here is an example of a setting node with its dialog instance variable set to the value #FontSettingDialog. In the case of fonts, it could be useful in order to allow the using of a specific cool dialog for font preferences settings.
------------------
FontSettings class>>fontSettingNode
	<setting> 
	^ (SettingManager newNode: 'Fonts')
		description: 'System fonts settings';
		dialog: #FontSettingDialog;
		parent: #uiSettingNode 
------------------

The dialog instance variable can be set for a setting value too. Then, neither the default value nor the type is needed:
------------------
UISettings class>>uiStyle
	<setting>
	^ UIStyle ifNil: [UIStyle := (SettingManager newSetting: 'UI style') 
			dialog: #UIStyleChooserDialog; 
			description: 'System style'].
------------------

6 SIMPLE SETTING WITH CHILDREN
A setting value can be a parent for another setting value. As an example, #gradientButtonLook can be a child of a boolean setting #advancedGUISetting:
------------------
MyClass class>>advancedGUISetting
	<setting>
	^ AdvancedGUISetting
		ifNil: [AdvancedGUISetting := 
						(SettingManager newSetting: 'Advanced GUI settings')
						parent: #uiSettingNode;
						default: true]
					
MyClass class>>gradientButtonLook
	<setting>
	^ GradientButtonLook
		ifNil: [GradientButtonLook := 
						(SettingManager newSetting: 'Gradient look for buttons')
						parent: #advancedGUISetting;
						default: true]
------------------

7 MANAGING SETTING VALUES

7.1 GETTING AND CHANGING A SETTING VALUE

Let's use the following example of a boolean setting declaration:
------------------
MyPackageSettings class>>mySetting
	<setting>
	^ MySetting ifNil: [MySetting := (SettingManager newSetting: 'My setting label') default: true]
------------------
										
The following two expressions are used in order to, respectively, get and set the value of the setting:
------------------
MyPackageSettings mySetting value. "get the value of the setting"
MyPackageSettings mySetting value: false. "change the value of the setting"
------------------

7.2 SETTING VALUE CHANGE NOTIFICATION

7.2.1 REGISTERING A LISTENER

Whatever object can be declared as a change listener for a particular setting: each time the setting value is changed, each listener is aware of the change by receiving a particular message. In order to declare a listener, a client object must send the #whenChangedSend:to: message to a setting. The first argument is a message selector and the second argument it a receiver for the message. Then, the receiver becomes a listener for the setting. The message selector can take zero or one argument. In the case of one argument, the changed setting value is passed as argument to the message send. Note that an object can be declared as a listener several times, each time with a different message selector.

As an example, lets take the example of the desktopColor setting:
------------------
DesktopSettings class>>desktopColor
	<setting>
	^ DesktopColor
		ifNil: [DesktopColor := (SettingManager newSetting: 'Desktop color') 
					parent: #uiColors;
					description: 'The color used for the desktop background';
					default: (MessageSend receiver: Color selector: #white)]
------------------

Each time the desktop color setting is changed, the World color should be changed according to the new setting value. A solution could be to declare the World as a listener for the desktopColor setting changes and make it change its color according to the desktopColor setting each time the desktopColor setting value is changed. This can be achieved from the class initialize method as below:

------------------
DesktopSettings class>>initialize
	self desktopColor whenChangedSend: #color: to: World.
------------------

7.2.2 UNREGISTERING A LISTENER

There is two ways to unregister a listener for a particular setting changes. 
- The first way is to globally unregister a listener whatever the message selector. After the listener is unregistered, it is totally ignored when the concerned setting is changed. This is achieved by sending a #forget: message to the setting with the listener as argument.

Concerning the desktopColor setting example, the World can be unregistered as shown below:
------------------
DesktopSettings desktopColor forget: World. "no more notification at all" 
------------------

- The second way is to unregister a listener for only a specific selector. This is achieved by sending a #forget:selector: message to the setting. The first argument is the listener and the second is a selector.

Concerning the desktopColor setting example, the World can be unregistered for only the #color: selector as shown below:
------------------
DesktopSettings desktopColor 
	forget: World 
	selector: #color:. "The World can still be notified using another selector" 
------------------
!

!SettingManager classSide methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 09:53'!
current
	"Answer the current manager."

	^ Current ifNil: [Current := SettingManager new]! !

!SettingManager classSide methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 07:11'!
itemSortBlock
	^ [:a :b | 
		((a order notNil and: [b order notNil]) and: [a order ~= b order])
			ifTrue: [a order < b order]
			ifFalse: [((a order isNil and: [b order isNil]) or: [a order = b order])
				ifTrue: [a label < b label]
				ifFalse: [a order ifNil: [false] ifNotNil: [true]]]]! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/24/2009 21:08'!
newMenu: aName 	
	^ self current newMenu: aName ! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 4/1/2009 12:21'!
newMenuItem: aName 	
	^ self current newMenuItem: aName ! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/25/2009 00:12'!
newMenuSiblings
	^ self current newMenuSiblings! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/26/2009 11:42'!
newMenuSiblings: aName
	^ self current newMenuSiblings: aName
! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 4/1/2009 16:03'!
newMenu: aName 
	^ MenuSettingNode new name: aName! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 4/1/2009 12:18'!
newMenuItem: aName 
	^ MenuElement new name: aName! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 00:12'!
newMenuSiblings
	^ MenuSiblings new ! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 3/26/2009 11:42'!
newMenuSiblings: aName
	^ self newMenuSiblings name: aName! !

Object subclass: #SettingMenuAssembler
	instanceVariableNames: 'treeHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Menu'!

!SettingMenuAssembler classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/30/2009 21:36'!
forKeywords: aCollectionOfRegExps 
	^ self new acceptableKeywords: aCollectionOfRegExps! !

!SettingMenuAssembler classSide methodsFor: 'instance creation' stamp: 'alain.plantec 4/3/2009 15:37'!
popUpMenu: aKeyword 
	^ self popUpMenu: aKeyword startingAt: nil
! !

!SettingMenuAssembler classSide methodsFor: 'instance creation' stamp: 'alain.plantec 9/18/2009 16:25'!
popUpMenu: aKeyword startingAt: aSelector 
	^ (self forKeywords: {aKeyword}) doPopUpMenuStartingAt: aSelector! !

!SettingMenuAssembler classSide methodsFor: 'instance creation' stamp: 'alain.plantec 4/3/2009 08:35'!
popUpWorldMenu
	^ self popUpWorldMenuStartingAt: nil! !

!SettingMenuAssembler classSide methodsFor: 'instance creation' stamp: 'alain.plantec 4/3/2009 08:23'!
popUpWorldMenuStartingAt: aSelector
	^ 	self popUpMenu: self worldMenuKeyword startingAt: aSelector! !

!SettingMenuAssembler classSide methodsFor: 'instance creation' stamp: 'alain.plantec 4/3/2009 08:48'!
worldMenuKeyword
	^ 'worldMenu'! !

!SettingMenuAssembler methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 11:45'!
acceptableKeywords: aCollectionOfRegExps 
	self treeHolder acceptableKeywords: aCollectionOfRegExps! !

!SettingMenuAssembler methodsFor: 'menu building' stamp: 'AlainPlantec 11/24/2009 11:45'!
buildMenuStartingAt: aSelector 
	| treeRoots menu |
	treeRoots := aSelector
				ifNil: [self treeHolder settingTreeRoots]
				ifNotNil: [self treeHolder
						deeplySelect: [:node | node item selector = aSelector]].
	menu := MenuMorph new.
	treeRoots
		do: [:c | self node: c menuItemIn: menu].
	treeRoots size = 1 
		ifTrue: [menu items size = 1
				ifTrue: [menu items first subMenu ifNotNil: [:sm | menu := sm]].
			menu title: treeRoots first item value name.
			menu addStayUpItem].
	^ menu! !

!SettingMenuAssembler methodsFor: 'menu building' stamp: 'alain.plantec 4/1/2009 14:48'!
doPopUpMenu
	self doPopUpMenuStartingAt: nil
! !

!SettingMenuAssembler methodsFor: 'menu building' stamp: 'alain.plantec 4/20/2009 14:33'!
doPopUpMenuStartingAt: aSelector 
	(self buildMenuStartingAt: aSelector)
		popUpEvent: nil
		in: World! !

!SettingMenuAssembler methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 11:46'!
newTreeHolder
	^ SettingTreeHolder new ! !

!SettingMenuAssembler methodsFor: 'menu building' stamp: 'alain.plantec 4/3/2009 08:11'!
node: aTreeNode menuItemIn: aMenu 
	| sub |
	aTreeNode contents
		ifEmpty: [aTreeNode item value menuItemIn: aMenu]
		ifNotEmpty: [sub := aTreeNode item value menuItemIn: aMenu.
			aTreeNode contents
				do: [:c | self node: c menuItemIn: sub]].
! !

!SettingMenuAssembler methodsFor: 'error handling' stamp: 'alain.plantec 4/1/2009 09:31'!
pragmaErrorOccured: aPragmaError
	Transcript show: aPragmaError message, String cr! !

!SettingMenuAssembler methodsFor: 'dependents access' stamp: 'AlainPlantec 11/24/2009 11:48'!
release
	treeHolder release.
	treeHolder := nil.
	super release! !

!SettingMenuAssembler methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 11:43'!
treeHolder
	^ treeHolder
		ifNil: [treeHolder := self newTreeHolder]! !

Object subclass: #SettingStyle
	instanceVariableNames: 'status'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Style'!

!SettingStyle commentStamp: 'alain.plantec 4/23/2009 07:36' prior: 0!
A SettingStyle provides a mean to store the state of all system settings according to specific user preferences and/or to some particular using (demonstration style with big fonts, laptop/desktop used at home or at work ...). The only behavior of a style is implemented by its load method. Thus, a style can be loaded programmatically as follow:
------------------
MyStyle new loadStyle
------------------
Where MyStyle is a subclass of SettingStyle which can implement a load method as below:
------------------
MyStyle>>load
	"load change a set of settings with some prefered value"
	MorphicSettings haloEnabled value: true.
	...
------------------

The SystemSettingBrowser makes it possible to manage SettingStyle sub-classes (create/update/delete/load/browse). See SystemSettingBrowser comment. 

Instance Variables
	status:		<Stream>

status
	- a stream or nil: used when loading in order to report any error
!

SettingStyle subclass: #DefaultSettingStyle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Style'!

!DefaultSettingStyle commentStamp: 'alain.plantec 4/20/2009 14:06' prior: 0!
A DefaultSettingStyle represents the default system style. System maintainers can use the SystemSettingBrowser in order to automatically build it. System users can load it in order to reset all standard settings according to their default state.

Instance Variables
!

!DefaultSettingStyle class methodsFor: 'accessing' stamp: 'AlainPlantec 12/14/2009 23:59'!
styleName
	^ 'Default' translated! !

!DefaultSettingStyle methodsFor: 'loading' stamp: 'AlainPlantec 12/14/2009 23:59'!
load
[AppearanceSystemSettings uiThemeClass: nil] on: Error do: [|message| message := 'Error while changing the setting: #uiThemeClass.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[UITheme currentSettings preferRoundCorner: nil] on: Error do: [|message| message := 'Error while changing the setting: #preferRoundCorner.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[SystemWindow fullScreenMargin: nil] on: Error do: [|message| message := 'Error while changing the setting: #fullScreenMargin.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[UITheme currentSettings fadedBackgroundWindows: nil] on: Error do: [|message| message := 'Error while changing the setting: #fadedBackgroundWindows.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[UITheme currentSettings fastDragging: nil] on: Error do: [|message| message := 'Error while changing the setting: #fastDragging.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[UITheme currentSettings preferGradientFill: nil] on: Error do: [|message| message := 'Error while changing the setting: #preferGradientFill.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[UITheme currentSettings flatMenu: nil] on: Error do: [|message| message := 'Error while changing the setting: #flatMenu.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[UITheme currentSettings autoMenuColor: nil] on: Error do: [|message| message := 'Error while changing the setting: #autoMenuColor.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[UITheme currentSettings menuWithIcons: nil] on: Error do: [|message| message := 'Error while changing the setting: #menuWithIcons.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[HaloMorph haloEnclosesFullBounds: nil] on: Error do: [|message| message := 'Error while changing the setting: #haloEnclosesFullBounds.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[HaloMorph showBoundsInHalo: nil] on: Error do: [|message| message := 'Error while changing the setting: #showBoundsInHalo.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[MorphicModel keyboardFocusOnMouseDown: nil] on: Error do: [|message| message := 'Error while changing the setting: #keyboardFocusOnMouseDown.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[MorphicModel mouseOverForKeyboardFocus: nil] on: Error do: [|message| message := 'Error while changing the setting: #mouseOverForKeyboardFocus.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[PluggableTextMorph showTextEditingState: nil] on: Error do: [|message| message := 'Error while changing the setting: #showTextEditingState.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[Morph balloonHelpEnabled: nil] on: Error do: [|message| message := 'Error while changing the setting: #balloonHelpEnabled.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[StringMorph editableStringMorph: nil] on: Error do: [|message| message := 'Error while changing the setting: #editableStringMorph.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[Morph defaultYellowButtonMenuEnabled: nil] on: Error do: [|message| message := 'Error while changing the setting: #defaultYellowButtonMenuEnabled.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[CommandHistory useUndo: nil] on: Error do: [|message| message := 'Error while changing the setting: #useUndo.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[CommandHistory infiniteUndo: nil] on: Error do: [|message| message := 'Error while changing the setting: #infiniteUndo.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[CommandHistory purgeUndoOnQuit: nil] on: Error do: [|message| message := 'Error while changing the setting: #purgeUndoOnQuit.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[AppearanceSystemSettings desktopColor: nil] on: Error do: [|message| message := 'Error while changing the setting: #desktopColor.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[AppearanceSystemSettings useDesktopGradientFill: nil] on: Error do: [|message| message := 'Error while changing the setting: #useDesktopGradientFill.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[AppearanceSystemSettings desktopGradientFillColor: nil] on: Error do: [|message| message := 'Error while changing the setting: #desktopGradientFillColor.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[AppearanceSystemSettings desktopGradientDirection: nil] on: Error do: [|message| message := 'Error while changing the setting: #desktopGradientDirection.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[AppearanceSystemSettings desktopGradientOrigin: nil] on: Error do: [|message| message := 'Error while changing the setting: #desktopGradientOrigin.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[AppearanceSystemSettings desktopImageFileName: nil] on: Error do: [|message| message := 'Error while changing the setting: #desktopImageFileName.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[Display fullScreen: false] on: Error do: [|message| message := 'Error while changing the setting: #displayFullscreen.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[Locale activated: nil] on: Error do: [|message| message := 'Error while changing the setting: #useLocale.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[TextMorphEditor useMultipleUndo: nil] on: Error do: [|message| message := 'Error while changing the setting: #useMultipleUndo.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[ParagraphEditor caseSensitiveFinds: nil] on: Error do: [|message| message := 'Error while changing the setting: #caseSensitiveFinds.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[ParagraphEditor walkAlongDisplayedLine: nil] on: Error do: [|message| message := 'Error while changing the setting: #walkAlongDisplayedLine.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[CodeHolder smartUpdating: nil] on: Error do: [|message| message := 'Error while changing the setting: #smartUpdating.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[CodeHolder browseWithPrettyPrint: nil] on: Error do: [|message| message := 'Error while changing the setting: #browseWithPrettyPrint.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[CodeHolder showAnnotationPane: nil] on: Error do: [|message| message := 'Error while changing the setting: #showAnnotationPane.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[CodeHolder optionalButtons: nil] on: Error do: [|message| message := 'Error while changing the setting: #optionalButtons.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[Debugger extraDebuggerButtons: nil] on: Error do: [|message| message := 'Error while changing the setting: #extraDebuggerButtons.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[CodeHolder decorateBrowserButtons: nil] on: Error do: [|message| message := 'Error while changing the setting: #decorateBrowserButtons.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[ChangeSet mustCheckForSlips: nil] on: Error do: [|message| message := 'Error while changing the setting: #mustCheckForSlips.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[CodeHolder diffsInChangeList: nil] on: Error do: [|message| message := 'Error while changing the setting: #diffsInChangeList.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[CodeHolder diffsWithPrettyPrint: nil] on: Error do: [|message| message := 'Error while changing the setting: #diffsWithPrettyPrint.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[FreeTypeSettings current monitorType: #LCD] on: Error do: [|message| message := 'Error while changing the setting: #monitorType.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[FreeTypeSettings updateFontsAtImageStartup: nil] on: Error do: [|message| message := 'Error while changing the setting: #updateFontsAtImageStartup.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[FreeTypeCache current cacheSize: 5000] on: Error do: [|message| message := 'Error while changing the setting: #cacheSize.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[FreeTypeSettings current hintingSymbol: #Light] on: Error do: [|message| message := 'Error while changing the setting: #hintingSymbol.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[FreeTypeSettings current glyphContrast: 50] on: Error do: [|message| message := 'Error while changing the setting: #glyphContrast.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[StandardFonts defaultFont: nil] on: Error do: [|message| message := 'Error while changing the setting: #defaultFont.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[StandardFonts codeFont: nil] on: Error do: [|message| message := 'Error while changing the setting: #codeFont.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[StandardFonts listFont: nil] on: Error do: [|message| message := 'Error while changing the setting: #listFont.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[StandardFonts menuFont: nil] on: Error do: [|message| message := 'Error while changing the setting: #menuFont.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[StandardFonts buttonFont: nil] on: Error do: [|message| message := 'Error while changing the setting: #buttonFont.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[StandardFonts windowTitleFont: nil] on: Error do: [|message| message := 'Error while changing the setting: #windowTitleFont.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[StandardFonts balloonFont: nil] on: Error do: [|message| message := 'Error while changing the setting: #balloonFont.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[StandardFonts haloFont: nil] on: Error do: [|message| message := 'Error while changing the setting: #haloFont.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[MCCodeTool showAnnotationPane: nil] on: Error do: [|message| message := 'Error while changing the setting: #showAnnotationPane.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[NetworkSystemSettings useHTTPProxy: nil] on: Error do: [|message| message := 'Error while changing the setting: #useHTTPProxy.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[HTTPSocket httpProxyPort: nil] on: Error do: [|message| message := 'Error while changing the setting: #httpProxyPort.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[HTTPSocket httpProxyServer: nil] on: Error do: [|message| message := 'Error while changing the setting: #httpProxyServer.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[NetworkSystemSettings useNetworkAuthentification: nil] on: Error do: [|message| message := 'Error while changing the setting: #useNetworkAuthentification.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[NetworkSystemSettings proxyUser: nil] on: Error do: [|message| message := 'Error while changing the setting: #proxyUser.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[NetworkSystemSettings proxyPassword: nil] on: Error do: [|message| message := 'Error while changing the setting: #proxyPassword.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[NetworkSystemSettings blabEmail: nil] on: Error do: [|message| message := 'Error while changing the setting: #blabEmail.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[PSMCPatchMorph usedByDefault: nil] on: Error do: [|message| message := 'Error while changing the setting: #polymorphDiffToolsUsedByDefault.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[SoundSettings soundEnabled: nil] on: Error do: [|message| message := 'Error while changing the setting: #soundEnabled.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[SoundSettings useThemeSounds: nil] on: Error do: [|message| message := 'Error while changing the setting: #useThemeSounds.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[SystemSupportSystemSettings soundThemeClass: nil] on: Error do: [|message| message := 'Error while changing the setting: #soundThemeClass.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[WorldState serverMode: nil] on: Error do: [|message| message := 'Error while changing the setting: #serverMode.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[SmalltalkImage checkSourcesFileAvailability: nil] on: Error do: [|message| message := 'Error while changing the setting: #checkSourcesFileAvailability.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[SmalltalkImage checkChangesFileAvailability: nil] on: Error do: [|message| message := 'Error while changing the setting: #checkChangesFileAvailability.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[Parser warningAllowed: nil] on: Error do: [|message| message := 'Error while changing the setting: #warningAllowed.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[Parser allowBlockArgumentAssignment: nil] on: Error do: [|message| message := 'Error while changing the setting: #allowBlockArgumentAssignment.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[Scanner allowUnderscoreAsAssignment: nil] on: Error do: [|message| message := 'Error while changing the setting: #allowUnderscoreAsAssignment.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[Deprecation raiseWarning: nil] on: Error do: [|message| message := 'Error while changing the setting: #raiseWarning.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[Deprecation showWarning: nil] on: Error do: [|message| message := 'Error while changing the setting: #showWarning.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[UserInterruptHandler cmdDotEnabled: nil] on: Error do: [|message| message := 'Error while changing the setting: #cmdDotEnabled.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[CPUWatcher cpuWatcherEnabled: nil] on: Error do: [|message| message := 'Error while changing the setting: #cpuWatcherEnabled.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[ImageSegment debugPrintSpaceLog: nil] on: Error do: [|message| message := 'Error while changing the setting: #debugPrintSpaceLog.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[WorldState debugShowDamage: nil] on: Error do: [|message| message := 'Error while changing the setting: #debugShowDamage.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[Debugger logDebuggerStackToFile: nil] on: Error do: [|message| message := 'Error while changing the setting: #logDebuggerStackToFile.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[Debugger restartAlsoProceeds: nil] on: Error do: [|message| message := 'Error while changing the setting: #restartAlsoProceeds.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[ObjectExplorer showIcons: nil] on: Error do: [|message| message := 'Error while changing the setting: #ObjectExplorerShowIcons.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[TasklistMorph keepOpen: nil] on: Error do: [|message| message := 'Error while changing the setting: #keepTaskListOpen.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[TaskbarMorph showTaskbar: nil] on: Error do: [|message| message := 'Error while changing the setting: #showTaskbar.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
[TaskbarMorph showWindowPreview: nil] on: Error do: [|message| message := 'Error while changing the setting: #showWindowPreview.'.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]].
! !

!SettingStyle classSide methodsFor: 'accessing' stamp: 'alain.plantec 4/8/2009 12:39'!
styleName
	"The style name used by the SystemSettingBrowser"
	^ self subclassresponsibility ! !

!SettingStyle methodsFor: 'loading' stamp: 'alain.plantec 3/19/2009 08:24'!
load
	^ self subclassResponsibility! !

!SettingStyle methodsFor: 'loading' stamp: 'alain.plantec 4/23/2009 07:41'!
loadStyle
	[self load]
		on: Error
		do: [| message |
			message := 'Error while loading Setting style ' , self class styleName.
			Transcript show: message , String cr.
			^ false].
	Transcript show: 'Setting style ' , self class styleName , ' loaded.' , String cr.
	^ true! !

!SettingStyle methodsFor: 'loading' stamp: 'alain.plantec 9/21/2009 09:24'!
loadStyleFrom: aRequestor 
	"load all my settings and report using a status 
	stream the requestor is supposed to provide"
	status := aRequestor status.
	[self load]
		on: Error
		do: [| message |
			message := 'Error while loading Setting style ' , self class styleName.
			status
				ifNil: [Transcript show: message , String cr]
				ifNotNil: [status nextPutAll: message;
						 cr].
			^ false].
	status nextPutAll: 'Setting style ' , self class styleName , ' loaded.';
		 cr.
	aRequestor styleLoaded.
	^ true! !

Object subclass: #SettingTreeBuilder
	instanceVariableNames: 'nodeList currentParent currentPragma'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingTreeBuilder class methodsFor: 'instance creation' stamp: 'AlainPlantec 11/24/2009 11:53'!
acceptableKeywords: aCollectionOfRegExps 
	^ self new acceptableKeywords: aCollectionOfRegExps 
! !

!SettingTreeBuilder methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 07:20'!
buildPragma: aPragma
	currentPragma := aPragma.
	aPragma methodClass theNonMetaClass perform: aPragma selector with: self.
	^ nodeList! !

!SettingTreeBuilder methodsFor: 'public tree building' stamp: 'AlainPlantec 12/2/2009 11:52'!
checkList: aSymbol
	^ self nodeClass: CheckListSettingDeclaration name: aSymbol
! !

!SettingTreeBuilder methodsFor: 'public tree building' stamp: 'AlainPlantec 11/24/2009 12:16'!
group: aSymbol
	^ self nodeClass: SystemSettingNode name: aSymbol
! !

!SettingTreeBuilder methodsFor: 'public tree building' stamp: 'AlainPlantec 12/5/2009 13:50'!
launcher: aSymbol
	^ self nodeClass: SystemSettingLauncher name: aSymbol
! !

!SettingTreeBuilder methodsFor: 'public tree building' stamp: 'AlainPlantec 12/2/2009 15:42'!
list: aSymbol
	^ self nodeClass: ListSettingDeclaration name: aSymbol
! !

!SettingTreeBuilder methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 11:53'!
nodeClass
	^ SettingTreeNode! !

!SettingTreeBuilder methodsFor: 'private tree building' stamp: 'AlainPlantec 11/24/2009 14:51'!
nodeClass: aClass name: aSymbol
	| node |
	node := self nodeClass with: aClass new.
	node item name: aSymbol.
	node pragma: currentPragma.
	node parentName: (currentParent ifNotNil: [currentParent name]).
	self nodeList add: node.
	^ (SettingTreeNodeBuilder new) node: node; builder: self; yourself! !

!SettingTreeBuilder methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 12:05'!
nodeList
	^ nodeList ifNil: [nodeList := OrderedCollection new]
! !

!SettingTreeBuilder methodsFor: 'private tree building' stamp: 'AlainPlantec 11/24/2009 13:35'!
parent: aNode while: aBlock
	| oldParent |
	oldParent := currentParent.
	currentParent := aNode.
	aBlock value.
	currentParent := oldParent! !

!SettingTreeBuilder methodsFor: 'public tree building' stamp: 'AlainPlantec 12/2/2009 11:47'!
pickOne: aSymbol
	^ self nodeClass: PickOneSettingDeclaration name: aSymbol
! !

!SettingTreeBuilder methodsFor: 'public tree building' stamp: 'AlainPlantec 11/24/2009 12:15'!
range: aSymbol
	^ self nodeClass: RangeSettingDeclaration name: aSymbol
! !

!SettingTreeBuilder methodsFor: 'public tree building' stamp: 'AlainPlantec 11/24/2009 12:15'!
setting: aSymbol
	^ self nodeClass: SettingDeclaration name: aSymbol
! !

Object subclass: #SettingTreeHolder
	instanceVariableNames: 'collector nodeList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingTreeHolder commentStamp: 'AlainPlantec 11/24/2009 15:21' prior: 0!
A SettingTreeHolder is responsible for the building of system setting trees from a collection of pragma.
Built tree nodes are instances of SettingTreeNode. Built trees are suitable for tree browsing with the help of a MorphTreeMorph (see SettingBrowser>>treeMorphIn: and SettingBrowser>>roots to know how a SettingBrowser is initializing its MorphTreeMorph with the help of a SettingTreeHolder). 

Below, two examples of tree building with a SettingCollector are shown.
---------------
(SettingTreeHolder acceptableKeywords: #('setting')) settingTreeRoots. "get system setting trees"
(SettingTreeHolder acceptableKeywords: #('.*Menu')) settingTreeRoots. "get all menus"
---------------

Instance Variables
	collector		<PragmaCollector>
	nodeList		<A list of SettingTreeNode>
!

!SettingTreeHolder classSide methodsFor: 'instance creation' stamp: 'alain.plantec 4/9/2009 15:50'!
acceptableKeywords: aCollectionOfRegExps 
	^ self new acceptableKeywords: aCollectionOfRegExps 
! !

!SettingTreeHolder methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 07:43'!
acceptableKeywords: aCollectionOfRegExps
	self collector filter: [:prg | prg methodClass isMeta and: [prg selector numArgs = 1 and: [aCollectionOfRegExps
				anySatisfy: [:rxString | prg keyword asString matchesRegex: rxString]]]].
	nodeList := nil.
	self collector reset.
! !

!SettingTreeHolder methodsFor: 'checking' stamp: 'AlainPlantec 11/24/2009 15:11'!
checkForUnknownParent
	self unclassified ifNotEmpty: [:nodesWithUnknownParent | | builder g |
		builder := SettingTreeBuilder new.
		g := (builder group: #nodesWithUnknownParent) node.
		self nodeList addFirst: g.
		g model: self.
		g item label: '*** Unclassified ***'.
		g item icon: MenuIcons smallDebugIcon.
		g item order: 0.0.
		nodesWithUnknownParent do: [:node | node parentName: #nodesWithUnknownParent]]! !

!SettingTreeHolder methodsFor: 'checking' stamp: 'AlainPlantec 12/7/2009 08:56'!
checkForUnknownTarget
	"check only root because other nodes with unknown target inherits it from its parent"
	self settingTreeRoots do: [:node | node item target ifNil: [node item target: (node pragma ifNotNil: [:prg | prg methodClass theNonMetaClass])]].
	self settingTreeRoots do: [:node | node checkForUnknownTarget].
! !

!SettingTreeHolder methodsFor: 'querying' stamp: 'AlainPlantec 12/9/2009 08:38'!
childrenOf: aNode 
	| children  idx order |
	"Get aNode children. Assign children order if one child has an order which is not nil"
	children := self nodeList select: [:p | p parentName = aNode settingDeclaration name].
	(children detect: [:n | n order notNil] ifNone:[])  ifNotNil: [:firstWithOrder |
		idx := children indexOf: firstWithOrder.
		order := firstWithOrder order.
		idx > 1
			ifTrue: [(idx - 1 to: 1) 
				do: [:pos | 
					(children at: pos) order: order - 1. 
					order := order - 1]].
		order := firstWithOrder order.
		(idx + 1 to: children size) 
			do: [:pos | 
				(children at: pos) order 
					ifNil:  [(children at: pos) order: order + 1] 
					ifNotNil: [order := (children at: pos) order].
				order := order + 1]].
	^ children! !

!SettingTreeHolder methodsFor: 'accessing' stamp: 'alain.plantec 10/19/2009 11:28'!
collector
	^ collector ifNil: [collector := PragmaCollector new]! !

!SettingTreeHolder methodsFor: 'querying' stamp: 'alain.plantec 9/19/2009 09:32'!
deeplyDetect: aBlock 
	self settingTreeRoots
		do: [:sub | (sub deeplyDetect: aBlock)
				ifNotNil: [:found | ^ found]].
	^ nil ! !

!SettingTreeHolder methodsFor: 'querying' stamp: 'alain.plantec 4/3/2009 07:53'!
deeplySelect: aBlock
	^ self deeplySelect: aBlock in: OrderedCollection new
! !

!SettingTreeHolder methodsFor: 'querying' stamp: 'alain.plantec 4/13/2009 08:04'!
deeplySelect: aBlock in: aCollection 
	self settingTreeRoots
		do: [:aRoot | aRoot deeplySelect: aBlock in: aCollection]. 
	^ aCollection! !

!SettingTreeHolder methodsFor: 'private tree building' stamp: 'AlainPlantec 11/27/2009 22:05'!
emptyNodeNamed: aSymbol
	(self nodeNamed: aSymbol)
! !

!SettingTreeHolder methodsFor: 'accessing' stamp: 'alain.plantec 9/18/2009 22:35'!
nodeClass
	^ SettingTreeNode! !

!SettingTreeHolder methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 08:46'!
nodeList
	| builder |
	^ nodeList 
		ifNil: [
			builder := SettingTreeBuilder new.
			self pragmasDo: [:p | builder buildPragma: p].
			nodeList := builder nodeList.
			nodeList do: [:n | n model: self].
			self checkForUnknownParent.
			self checkForUnknownTarget.
			self nodeList]! !

!SettingTreeHolder methodsFor: 'private tree building' stamp: 'AlainPlantec 11/24/2009 09:35'!
nodeNamed: aSymbol
	^ self nodeNamed: aSymbol ifAbsent: []
! !

!SettingTreeHolder methodsFor: 'private tree building' stamp: 'AlainPlantec 11/24/2009 09:34'!
nodeNamed: aSymbol ifAbsent: aBlock
	^ self nodeList detect: [:d | d settingDeclaration name = aSymbol] ifNone: aBlock! !

!SettingTreeHolder methodsFor: 'querying' stamp: 'alain.plantec 10/19/2009 13:56'!
pragmasDo: aBlock
	^  self collector do: aBlock! !

!SettingTreeHolder methodsFor: 'querying' stamp: 'AlainPlantec 12/5/2009 08:51'!
retainedNodesFromList: aListOfNodes
	| retained |
	retained := OrderedCollection new.
	aListOfNodes do: [:n | [n item precondition value ifTrue: [retained add: n]] on: Error do: [retained add: n]].
	^ retained! !

!SettingTreeHolder methodsFor: 'querying' stamp: 'AlainPlantec 12/5/2009 08:51'!
settingTreeRoots
	^ self retainedNodesFromList: ((self nodeList select: [:n | n parentName isNil]) asArray sort: self sortBlock) asOrderedCollection.
! !

!SettingTreeHolder methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 09:42'!
sortBlock
	^ [:a :b | SettingManager itemSortBlock value: a settingDeclaration value: b settingDeclaration]! !

!SettingTreeHolder methodsFor: 'querying' stamp: 'AlainPlantec 11/24/2009 12:01'!
unclassified
	^ self nodeList select: [:node | node parentName notNil and: [node parentNode isNil]].! !

!SettingTreeHolder methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 11:51'!
updateList
	nodeList := nil.
! !

!SettingTreeHolder methodsFor: 'updating' stamp: 'alain.plantec 10/19/2009 11:37'!
whenChangedSend: aSelector to: aTarget
	self collector whenChangedSend: aSelector to: aTarget.
	self collector whenResetSend: aSelector to: aTarget.! !

Object subclass: #SettingTreeNodeBuilder
	instanceVariableNames: 'node builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingTreeNodeBuilder methodsFor: 'private tree building' stamp: 'AlainPlantec 11/24/2009 13:34'!
asParentWhile: aBlock
	builder parent: self while: aBlock
! !

!SettingTreeNodeBuilder methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 13:33'!
builder: aTreeBuilder
	builder := aTreeBuilder! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:50'!
default: anObject
	node item  default: anObject
! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
description: aText
	node item description: aText! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
dialog: aSymbol
	node item dialog: aSymbol
! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
domainValues: aCollection 
	node item domainValues: aCollection 
! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
domainValuesGetter: aValuable 
	node item domainValuesGetter: aValuable 
! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
getSelector: aSymbol
	node item getSelector: aSymbol
! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
ghostHelp: aString
	node item ghostHelp: aString
! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
icon: aForm
	node item icon: aForm! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
label: aStringOrBlockOrMessageSend
	node item label: aStringOrBlockOrMessageSend.
! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 14:02'!
name
	^ node item name
! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
name: aStringOrBlockOrMessageSend
	node item name: aStringOrBlockOrMessageSend.
! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/27/2009 23:26'!
noOrdering
	node item noOrdering
! !

!SettingTreeNodeBuilder methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 12:43'!
node
	^ node! !

!SettingTreeNodeBuilder methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 12:43'!
node: aSettingTreeNode
	node := aSettingTreeNode! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 12/3/2009 16:21'!
notInStyle
	node item notInStyle! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
order: aNumber
	node item order: aNumber
! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
parent: aSymbol
	node parentName: aSymbol! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:52'!
parentName
	^ node parentName
	! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:52'!
parentName: aSymbol
	node parentName: aSymbol.
	! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 12/5/2009 08:44'!
precondition: aValuable
	node item precondition: aValuable
! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:52'!
range: anInterval
	node item range: anInterval
! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 12/5/2009 13:52'!
script: aSymbol
	node item script: aSymbol
! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:52'!
selector: aSymbol
	node item selector: aSymbol
! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:52'!
setSelector: aSymbol
	node item setSelector: aSymbol
! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:52'!
target: anObject
	node item target: anObject
! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/26/2009 21:39'!
targetSelector: aSelector
	node item targetSelector: aSelector
! !

!SettingTreeNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:52'!
type: anObject
	node item type: anObject
! !

!SettingTreeNodeBuilder methodsFor: 'public tree building' stamp: 'AlainPlantec 11/24/2009 12:40'!
with: aBlock
	self asParentWhile: aBlock! !
